unit BW;

interface

procedure DoBW( Name: String );

implementation

uses VGAGraph, Frames, CRT, Musax;

const
  BWCount = 136;

procedure DoBW( Name: String );
var
  Pal:		TRGBPalette;
  Pic:		TImage;
  I:		Integer;
  BackColor,
  PicNum:	Byte;

begin
{$IFDEF DEBUG}
  WriteLn( MemF, 'BW init' );
{$ENDIF}
  StartMusic( 'GLITCH.004' );
  FillChar( Pal, SIzeOf(Pal), 0 );
  Pic.Load( Name );
  SetPalette( @Pal );
  CopyPage( Pic.Data, Screen );
  Pic.Done;
  FrameCount := 0;
  while FrameCount < BWCount do
  begin
    BackColor := Random(2)*63;
    FillChar( Pal, SizeOf(Pal), BackColor );
    PicNum := 1 shl Random(8);
    for I := 0 to 255 do
    begin
      if (I and PicNum) > 0 then
      begin
	Pal[I].R := 63-BackColor;
	Pal[I].G := 63-BackColor;
	Pal[I].B := 63-BackColor;
      end;
    end;
{    WaitNextFrame;}
    WaitNextFrame;
    SetPalette(@Pal);
    if KeyPressed then Abort;
    if FrameCount >= BWCount-32 then
      SetVolume( (BWCount-FrameCount)*2 );
  end;
  FillChar( Pal, SIzeOf(Pal), 0 );
  SetPalette(@Pal);
  ClearPage(Screen);
  StopMusic;
{$IFDEF DEBUG}
  WriteLn( MemF, 'BW done' );
{$ENDIF}
end;

end.