{$I DEBUG}
unit Credits;

interface

function Init: Boolean;
procedure Run;
procedure Done;

implementation

uses VgaGraph, CRT, Fonts, Objects, Frames, RStream, Musax;

procedure DoOper( FromBuf, ToBuf: Pointer; Oper: PBuffer );
const
  Shift: Word = 0;
begin
asm
  push ds
  mov ax,Shift
  lds si,FromBuf
  les si,ToBuf
  xor bh,bh
  mov cx,256
  db $0F,$B4,$7E,6 {lfs di,Oper}
  push bp
  mov bp,ax
  mov ax,1024
@loop_y:
  push cx
  mov cx,256
  push di
@loop_x:
  db $64,$8A,$3D {mov bh,fs:[di]}
  add di,ax
  db $64,$8A,$1D {mov bl,fs:[di+1024]}
  sub di,ax
  mov bl,[si+bx]
@shift:
  mov es:[si+bp],bl
  inc di
  inc si
  loop @loop_x
  pop di
{  inc di}
  inc ax
  pop cx
  loop @loop_y
  pop bp
  pop ds
end;
  Inc( Shift, 256+2 );
end;

const
  XMax	= 5;
  XMin	= 2;
  YMax	= 4;
  YMin	= 1;

  TextCount:	Word = 20;

var
  Pic:		TImage;
{  Buf1,}
  Buf2,
  Tmp:		Pointer;
  RealOper,
  Oper: 	PBuffer;
  I, J:		Integer;
  Offset,
  OfsStep:	Byte;
  XAmp, YAmp,
  XStep, YStep:	Integer;
  Scroller:	TCollection;
  Font:		TFont;
  Sprite:	PSprite;
  CurPal:	TRGBPalette;
  CurScrollPos:	Integer;
  TextLines:	TCollection;
  S:		TRStream;
  SS:		String;
  Ending:	Boolean;
  EndCount:	Integer;

function Init: Boolean;
begin
{  Buf1 := DosAllocMem( 65536 );}
  Buf2 := DosAllocMem( 65536 );
  Oper := DosAllocMem( 1024*2 );
  RealOper := DosAllocMem( 1024*2 );
  Scroller.Init( 30, 1 );
  if not Pic.Load( 'LIVER3.NEW' ) or
     {(Buf1=nil) or} (Oper=nil) or (RealOper=nil) or
     not S.Init( 'CREDITS.TXT' ) or
{     not (Font.Load( 'AVANTGAR.FNT')) then}
     not (Font.Load( 'BANKGO13.FNT')) then

  begin
    Init := False;
  end
  else
  begin
    SetModeQ;
    FillChar( CurPal, SizeOf(CurPal), 0 );
{    MoveSeg( Pic.Data, Buf1 );}
    Offset := 0; OfsStep := 2;
    XAmp := XMax; YAmp := YMax;
    XStep := 1; YStep := 1;
    CurScrollPos := VRes+20;
    for I := 0 to 1023 do
      Oper^[I] := Round( Sin(Pi*I/64)*YMax );
    for I := 0 to 1023 do
      Oper^[1024+I] := Round( Sin(Pi*I/64)*XMax );
    Init := True;
  end;
  TextLines.Init(1,1);
  while S.Status = stOk do
  begin
    SS := GetLine(S);
    TextLines.Insert( NewStr(SS) );
  end;
  S.Done;
  Pic.Palette^[253].R := 63;
  Pic.Palette^[253].B := 63;
  Pic.Palette^[253].G := 40;

  Pic.Palette^[254].R := 63;
  Pic.Palette^[254].B := 40;
  Pic.Palette^[254].G := 63;

  Pic.Palette^[255].R := 20;
  Pic.Palette^[255].B := 40;
  Pic.Palette^[255].G := 63;
  Ending := False;
  EndCount := 63;
end;

procedure Run;
var
  FileName: 	String;
  Delta,
  Prev:		LongInt;
  SS:		String;
  C:		Char;
begin
  FrameCount := 0; Prev := 0;
  repeat
    for I := 0 to 511 do
    begin
      RealOper^[I+Offset] := Integer(ShortInt(Oper^[I+Offset]))*YAmp div YMax;
      RealOper^[1024+I+Offset] := Integer(ShortInt(Oper^[1024+I+Offset]))*XAmp div XMax;
    end;
{    DoOper( Buf1, Screen, @RealOper^[Offset] );}
    DoOper( Pic.Data, Buf2, @RealOper^[Offset] );
{    MoveSeg( Pic.Data, Buf2 );}
{    Tmp := Buf1; Buf1 := Buf2; Buf2 := Tmp;}
    Inc(Offset,OfsStep);
{    if (Offset = 0) or (Offset = 32) then OfsStep := -OfsStep;}
    if (YAmp <= YMin) or (YAmp >= YMax) then YStep := -YStep;
    Inc( YAmp, YStep );
    if (XAmp <= XMin) or (XAmp >= XMax) then XStep := -XStep;
    Inc( XAmp, XStep );

    if CurScrollPos <= VRes then
    begin
      if String(TextLines.At(TextCount)^)[1] <> '#' then
      begin
	if String(TextLines.At(TextCount)^) <> '' then
	begin
	  C := String(TextLines.At(TextCount)^)[1];
	  SS := Copy( String(TextLines.At(TextCount)^), 2,
		      Length(String(TextLines.At(TextCount)^))-1 );
	  Sprite := Font.CreateStr( SS );
	  if Sprite <> nil then
	  begin
	    case C of
	    '>':
	      begin
		Sprite^.Origin.X := HRes-Sprite^.Size.X;
		Sprite^.AddConst := Byte(-1);
	      end;
	    '<':
	      begin
		Sprite^.Origin.X := 0;
		Sprite^.AddConst := Byte(-2);
	      end;
	    else
	      begin
		Sprite^.Origin.X := (HRes-Sprite^.Size.X) div 2;
		Sprite^.AddConst := 0;
	      end;
	    end;
	    Sprite^.Origin.Y := CurScrollPos;
	    Sprite^.Step.Y := -1;
	    Sprite^.Step.X := 0;
	    Scroller.Insert( Sprite );
	  end;
	end;
	Inc( CurScrollPos, 25 );
      end
      else
      begin
	FileName := Copy( String(TextLines.At(TextCount)^), 2,
			  Length(String(TextLines.At(TextCount)^))-1 );
{$IFDEF DEBUG}
	WriteLn( MemF, FileName );
{$ENDIF}
	Sprite := New( PSprite, Load( FileName ) );
	if Sprite <> nil then
	begin
	  Sprite^.Origin.X := (HRes-Sprite^.Size.X) div 2;
	  Sprite^.Origin.Y := CurScrollPos;
	  Sprite^.Step.Y := -1;
	  Sprite^.Step.X := 0;
	  Scroller.Insert( Sprite );
	  Inc( CurScrollPos, Sprite^.Size.Y+5 );
	end;
      end;
      Inc( TextCount ); TextCount := TextCount mod TextLines.Count;
    end;

    if Scroller.Count > 0 then
    begin
      Sprite := PSprite(Scroller.At(0));
      if Sprite^.Origin.Y+Sprite^.Size.Y < 0 then Scroller.Free(Sprite);
    end;

    Delta := FrameCount-Prev;
    Prev := FrameCount;
    Dec( CurScrollPos, Delta );
    for J := 0 to Scroller.Count-1 do
    begin
      Sprite := PSprite(Scroller.At(J));
      Sprite^.Move( Delta );
      Sprite^.ShowAddConstT(Buf2);
    end;
    if KeyPressed and not Ending then
    begin
      Ending := True;
    end;
    if Ending then
    begin
      for J := 0 to 255 do
      begin
	if CurPal[J].R > 0 then Dec(CurPal[J].R);
	if CurPal[J].G > 0 then Dec(CurPal[J].G);
	if CurPal[J].B > 0 then Dec(CurPal[J].B);
      end;
      SetVolume(EndCount);
      Dec(EndCount);
      if EndCount = 0 then Abort;
    end
    else
    begin
      for J := 0 to 255 do
      begin
	if CurPal[J].R < Pic.Palette^[J].R then Inc(CurPal[J].R);
	if CurPal[J].G < Pic.Palette^[J].G then Inc(CurPal[J].G);
	if CurPal[J].B < Pic.Palette^[J].B then Inc(CurPal[J].B);
      end;
    end;
    SetPalette( @CurPal );
{    WaitNextFrame;}
    MoveSeg( Buf2, Screen );
  until False;
end;

procedure Done;
begin
{  DosFreeMem( Buf1 );}
  DosFreeMem( Buf2 );
  DosFreeMem( Oper );
  DosFreeMem( RealOper );
  Font.Done;
  Scroller.Done;
  Pic.Done;
end;

end.