{$I DEBUG}
unit Crow;

interface

procedure PrepareCrow( Buffer: Pointer );
procedure DoCrow( Buffer: Pointer );

implementation

uses Poly2D, Objects, VGAGraph, Frames, Musax;

const
  Steps=8;
  Length = 80;
  Figs = 5;

procedure PrepareCrow( Buffer: Pointer );
var
  P:		PPoly2D;

begin
   New( P, Init(@PDrawHLine,0) );
   P^.LoadDXF('CROW0.DXF');
   P^.Draw(Buffer);
   Dispose(P,Done);
end;

procedure DoCrow( Buffer: Pointer );
var
  P,PP:		PPoly2D;
  Name:		String;
  I, J, K:	Integer;
  Prev, Delta:	LongInt;
  Phases:	array[0..10] of PPoly2D;
  VScreen:	Pointer;

begin
   FrameCount := 0;
   Name := 'CROW0.DXF';
   New( P, Init(@PDrawHLine,0) );
   P^.LoadDXF(Name);
   for I := 0 to Figs do
   begin
     New(Phases[I],Init(@PDrawHLine,0));
     Phases[I]^.LoadDXF(Name);
     Inc( Name[5] );
   end;
   VScreen := DosAllocMem( 64000 );

   for I := 0 to 3 do
   begin
     FrameCount := 0;
     while FrameCount < Steps do
     begin
       CopyPage( Buffer, VScreen );
       P^.MorphTo(Phases[I],Phases[I+1],FrameCount,Steps);
       P^.Draw(VScreen);
       WaitNextFrame;
       CopyPage( VScreen, Screen );
     end;
   end;

   K := 0;
   for I := 0 to 5 do
   begin
     FrameCount := 0;
     Prev := 0;
     while FrameCount < Steps do
     begin
       CopyPage( Buffer, VScreen );
       Delta := FrameCount - Prev;
       Inc(K,Delta);
       Prev := FrameCount;
       for J := 0 to Delta do
       begin
	 Phases[4]^.Scale( 160,90,1.06,1.06);
	 Phases[5]^.Scale( 160,90,1.06,1.06);
       end;
       P^.MorphTo(Phases[4],Phases[5],FrameCount,Steps);
       P^.Draw(VScreen);
       CopyPage( VScreen, Screen );
       WaitNextFrame;
{       SetVolume( 64-K*5 div 3 );}
     end;
     PP := Phases[5]; Phases[5] := Phases[4]; Phases[4] := PP;
   end;

   DosFreeMem( VScreen );
   Dispose(P,Done);
   for I := 0 to 5 do
   begin
     Dispose(Phases[I],Done);
   end;
end;

end.