{$I DEBUG}
unit FireGlitch;

interface

function Init( BackPic: Pointer ): Boolean;
procedure Run;
procedure Done;

implementation

uses CRT, Objects, Memory, PCX, VGAGraph, Frames, RStream;

const
  PalWidth	= 128;

procedure Line( Buffer: Pointer; X1, Y1, X2, Y2: Integer; Color: Byte );
var
  DX, Eps, A, B, A2, B2, XCrit, DY, Len, I:	Integer;
begin
  DX := 1;
  A := X2-X1;
  if A<0 then
  begin
    DX := -1;
    A := -A;
  end;
  DY := 1;
  B := Y2-Y1;
  if B<0 then
  begin
    DY := -1;
    B := -B;
  end;
  A2 := A*2;
  B2 := B*2;
  XCrit := -B + A2;
  Eps := 0;
  if B > A then Len := B else Len := A;
  for I := 1 to Len do
  begin
    if (X1>=0) and (Y1>=0) and (X1<313) and (Y1<200) then
    begin
      asm
	les di,Buffer
	mov ax,320
	mul Y1
	add di,ax
	add di,X1
	mov ax,Y1
	mov al,Color
	mov ah,al
	stosw
	stosw
	add di,318
	stosw
	stosw
      end;
    end;
    if (X1=X2) and (Y1=Y2) then Break;
    if Eps <= XCrit then
    begin
      Inc( X1, DX );
      Inc( Eps, B2 );
    end;
    if (Eps>=A) or (A<=B) then
    begin
      Inc( Y1, DY );
      Dec( Eps, A2 );
    end;
  end;
end;

var
  CX,
  CY:	Integer;
  Ofss:	array[0..31] of Integer;

procedure MoveTo( Buf: Pointer; X,Y: Integer );
begin
  CX := X;
  CY := Y;
end;

procedure LineTo( Buf: Pointer; X,Y: Integer; Color: Byte );
begin
  Line( Buf, CX,CY, X,Y, Color );
  CX := X; CY := Y;
end;

var
  Tmp,
  Image,
  VScreen,
  Back:		Pointer;
  Pal:		TRGBPalette;
  F:		TRStream;
  S:		String;
  EndDXF:	Boolean;
  Tmp1,
  Tmp2:		Integer;

function Init( BackPic: Pointer ): Boolean;
var
  I:	Integer;
begin
  GetPalette( @Pal );
  FillChar( Pal[128], SizeOf(Pal) div 2, 0 );
  for I := 0 to 63 do
  begin
    Pal[I+128].R := I;
    Pal[255-I].R := I;
    if I > 31 then
    begin
      Pal[I+128].G := I-32;
    end;
  end;
  SetPalette( @Pal );
  Image := DosAllocMem( 65536 );
  VScreen := DosAllocMem( 65536 );
  Tmp := DosAllocMem( 64000 );
  if (Image = nil) or (VScreen = nil) or (Tmp = nil) then
  begin
    Init := False;
    Exit;
  end;
  Back := BackPic;
{$IFDEF __BPREAL__}
  FillChar( VScreen^, 65535, 0 );
  FillChar( Image^, 65535, 0 );
{$ENDIF}
  F.Init( 'GLITCH.DXF' );
  EndDXF := False;
  Init := True;
end;

procedure Done;
begin
  F.Done;
  DosFreeMem( Image );
  DosFreeMem( VScreen );
  DosFreeMem( Tmp );
end;

const
  Spaces = [' ',#9,#10,#13,':',','];

function GetToken: String;
var
  S:	String;
  C:	Char;
begin
  S := '';
  repeat F.Read( C, 1 ) until not (C in Spaces) or (F.Status<>stOk);
  repeat
    S := S + C;
    F.Read( C, 1 )
  until (C in Spaces) or (F.Status<>stOk);
{  WriteLn( MemF, S );}
  GetToken := S;
end;

function GetLine: String;
var
  S:	String;
  C:	Char;
begin
  S := '';
  C := #0;
  repeat F.Read( C, 1 ) until not (C in Spaces) or (F.Status<>stOk);
  while (C <> #13) and (F.Status=stOk) do
  begin
    S := S + C;
    F.Read( C, 1 )
  end;
  if Pos( 'EOF', S ) <> 0 then EndDXF := True;
  GetLine := S;
end;

procedure Run;
var
  _dx:		Word;
  NewLine:	Boolean;
  X,Y:		Real;
  I:		Integer;
  NoUpdate:	Boolean;
begin
  FrameCount := 0;
  NoUpdate := False;
  _dx := 0;
  for I := 0 to 31 do
    Ofss[I] := 3 + Random(3);
  repeat
    asm
      push ds
      mov dx,_dx
      les si,Image
      {lfs bx,Back}
      db $0F,$B4,$1E; dw offset Back
      lds bx,VScreen
  @loop:
      cmp bx,64000
      jae @no_inc
      mov al,[bx]

      cmp al,128
      jb @no_inc
{
      cmp NoUpdate,0
      je @fire
      dec al
      mov byte ptr [bx+320],al
      mov byte ptr [bx-320],al
      mov byte ptr [bx+1],al
      mov byte ptr [bx-1],al
      mov byte ptr [bx],al
      jmp @no_inc
@fire:
}
      dec al
      dec al
      dec al
      mov byte ptr [bx+320],al
      inc al
      mov byte ptr [bx+1],al
      mov byte ptr [bx-1],al

  {    mov byte ptr [bx],al}
      test dx,$8000
      jne @shift
      mov byte ptr [bx-640],al
      inc al
      mov byte ptr [bx-320],al
      jmp @no_inc
  @shift:
      mov byte ptr [bx-639],al
      inc al
      mov byte ptr [bx-319],al

  @no_inc:
      add bx,dx
      inc dx

      cmp NoUpdate,0
      jne @no_draw
      mov si,64000-1
      sub si,bx
      mov al,es:[si]
      or al,al
      je @no_draw
      mov [si],al

  @no_draw:
      test dx,$1FFF
      jne @loop

      mov _dx,dx

      pop ds
      push ds
      les di,Tmp
      lds di,VScreen
      mov cx,64000
  @copy_loop:
      mov al,[di]
      cmp al,135
      jae @copy
      {mov al,fs:[di]}
      db $64,$8A,$05
@copy:
      mov es:[di],al
      inc di
      loop @copy_loop
      pop ds
    end;

{
    if N <= 45 then Line( Image, PX[L1[N div 3]], 200-PY[L1[N div 3]],
				 PX[L2[N div 3]], 200-PY[L2[N div 3]], 180 );
}

    if not EndDXF and (FrameCount mod 2 = 0) and (F.Status = stOk) then
    begin
      S := GetLine;
      repeat
	if S = 'POLYLINE' then NewLine := True;
	S := GetLine;
      until (S = 'VERTEX') or EndDXF;
      if not EndDXF then
      begin
	S := GetLine;
	S := GetLine;
	S := GetLine;
	S := GetLine;
	Val( S, X, I );
	S := GetLine;
	S := GetLine;
	Val( S, Y, I );
	if NewLine then
	begin
	  MoveTo( Image, Round(X)+150, 100-Round(Y) );
	  NewLine := False;
	end
	else
	begin
	  LineTo( Image, Round(X)+150, 100-Round(Y), 190 );
	end;
      end;
    end;

    if FrameCount > 260 then NoUpdate := True;

    if NoUpdate then
    begin
      for I := 0 to 31 do
      begin
	Tmp1 := Ofss[I]*320;
	Tmp2 := I*10;
	asm
	  les di,VScreen
	  add di,Tmp2
	  add di,64000-320*5
	  sub di,Tmp1
	  mov cx,5
@loop1:
	  push di
	  push cx
	  mov cx,190
@loop2:
	  mov ax,es:[di]
	  add di,Tmp1
	  mov es:[di],ax
	  sub di,Tmp1
	  sub di,320
	  loop @loop2
	  pop cx
	  pop di
	  add di,2
	  loop @loop1
	end;
      end;
    end;

    if FrameCount > 340 then
    begin
      for I := 128 to 255 do
      begin
	if Pal[I].R > 0 then Dec( Pal[I].R, 1 );
	if Pal[I].G > 0 then Dec( Pal[I].G, 1 );
	if Pal[I].B > 0 then Dec( Pal[I].B, 1 );
      end;
    end;
{
    if N > 290 then
    begin
      for I := 0 to 127 do
      begin
	if Pal[I].R > 0 then Dec( Pal[I].R, 1 );
	if Pal[I].G > 0 then Dec( Pal[I].G, 1 );
	if Pal[I].B > 0 then Dec( Pal[I].B, 1 );
      end;
    end;
}
    WaitNextFrame;
    SetPalette( @Pal );
    asm
      push ds
      mov ax,SegA000
      mov es,ax
      lds di,Tmp
      xor si,si
      mov cx,32000
      rep movsw
      pop ds
    end;
    if FrameCount >= 400 then Exit;
  until KeyPressed;
  ReadKey;
end;

end.