{$I DEBUG}
unit Flips;

interface

uses VGAGraph;

procedure FlipLines( PTo: PImage; Width, Steps: Integer );
procedure FlipShift( PTo: PImage );

implementation

uses CRT;

procedure FlipLines( PTo: PImage; Width, Steps: Integer );
var
  I,J,
  K,W,N:  	Integer;
  VScreen:	PScreenBuffer;
begin
  VScreen := AllocPage;
  if VScreen = nil then Halt;
  CopyPage( Screen, VScreen );
  for I := 0 to Steps-1 do
  begin
    W := Round( Width*Cos( Pi/2/Steps*I ) );
    for J := 1 to VRes div Width do
    begin
      for K := 0 to (Width-W) div 2-1 do
      begin
	FillChar( Screen^[(J-1)*Width+K], HRes, 0 );
	FillChar( Screen^[J*Width-K], HRes, 0 );
      end;
      if W = 0 then Continue;
      for K := 0 to W div 2 do
      begin
	N := Width*K div W;
	Move( VScreen^[(J-1)*Width+N], Screen^[(J-1)*Width+(Width-W) div 2+K], HRes );
	Move( VScreen^[J*Width-N-1], Screen^[J*Width-K-(Width-W) div 2], HRes );
      end;
    end;
  end;
  ClearPage( Screen );
{  PTo^.Palette^[0].R := 0; PTo^.Palette^[0].G := 0; PTo^.Palette^[0].B := 0;}
  SetPalette( PTo^.Palette );
  for I := 0 to Steps-1 do
  begin
    W := Round( Width*Sin( Pi/2/Steps*I ) );
    for J := 1 to VRes div Width do
    begin
      if W = 0 then Continue;
      for K := 0 to W div 2 do
      begin
	N := Width*K div W;
	Move( PScreenBuffer(PTo^.Data)^[(J-1)*Width+N], Screen^[(J-1)*Width+(Width-W) div 2+K], HRes );
	Move( PScreenBuffer(PTo^.Data)^[J*Width-N-1], Screen^[J*Width-K-(Width-W) div 2], HRes );
      end;
    end;
  end;
  DosFreeMem( VScreen );
end;

procedure FlipShift( PTo: PImage );
var
  Shift:	array[0..400] of Integer;
  Offs:		array[0..400] of Integer;
  I:		Integer;
  VScreen:	PScreenBuffer;
  WasUpdates:	Boolean;
  Pal:		TRGBPalette;
begin
  VScreen := AllocPage;
  if VScreen = nil then Halt;
  CopyPage( Screen, VScreen );
  GetPalette( @Pal );
  for I := 0 to VRes-1 do
  begin
    repeat Shift[I] := 300-Random(700) until Abs(Shift[I]) > 200;
    Shift[I] := Shift[I]*2;
    Offs[I] := 0;
  end;
  repeat
    WasUpdates := False;
    for I := 0 to 255 do
    begin
      if Pal[I].R > PTo^.Palette^[I].R then Dec( Pal[I].R );
      if Pal[I].R < PTo^.Palette^[I].R then Inc( Pal[I].R );
      if Pal[I].G > PTo^.Palette^[I].G then Dec( Pal[I].G );
      if Pal[I].G < PTo^.Palette^[I].G then Inc( Pal[I].G );
      if Pal[I].B > PTo^.Palette^[I].B then Dec( Pal[I].B );
      if Pal[I].B < PTo^.Palette^[I].B then Inc( Pal[I].B );
    end;
    SetPalette( @Pal );
    for I := 0 to VRes-1 do
    begin
      if Shift[I] <> 0 then WasUpdates := True;
      Inc( Offs[I], Shift[I] );
      if Offs[I] > HRes*100 then
      begin
	Shift[I] := 0;
	Offs[I] := HRes*100;
      end;
      if Offs[I] < -HRes*100 then
      begin
	Shift[I] := 0;
	Offs[I] := -HRes*100;
      end;
      if Offs[I] > 0 then
      begin
	Move( VScreen^[I], Screen^[I][ Offs[I] div 100 ], HRes-Offs[I] div 100 );
	Move( PScreenBuffer(PTo^.Data)^[I][ HRes-Offs[I] div 100 ], Screen^[I], Offs[I] div 100 );
      end;
      if Offs[I] < 0 then
      begin
	Move( VScreen^[I][HRes+Offs[I] div 100], Screen^[I], HRes+Offs[I] div 100 );
	Move( PScreenBuffer(PTo^.Data)^[I], Screen^[I][ HRes+Offs[I] div 100 ], -Offs[I] div 100 );
      end;
    end;
  until not WasUpdates;
  DosFreeMem( VScreen );
end;

end.