{$I DEBUG}
unit Frames;

interface

procedure InitFrames;
procedure DoneFrames;
procedure WaitNextFrame;
procedure Abort;

var
  FrameCount: LongInt;

implementation

uses VGAGraph, DOS, Musax, RStream, CRT;

var
  Ready:	Boolean;
  Old1C:	Pointer;

procedure Int1C; interrupt;
begin
  Ready := True;
  Inc(FrameCount);
end;

procedure InitFrames;
begin
  GetIntVec( $1C, Old1C );
  SetIntVec( $1C, @Int1C );
end;

procedure DoneFrames;
begin
  SetIntVec( $1C, Old1C );
end;

procedure WaitNextFrame;
begin
  repeat until Ready = True;
  WaitRetrace;
  Ready := False;
end;

procedure Abort;
var
  Pal : TRGBPalette;
begin
  while KeyPressed do ReadKey;
  DoneFrames;
  DoneMusic;
  FreeEMSCopy;
  FillChar(Pal,SizeOf(Pal),0);
  SetPalette(@Pal);
  asm
    mov ax,3
    int 10h
  end;
{$IFDEF DEBUG}
  Close(MemF);
{$ENDIF}
  Halt;
end;

begin
  FrameCount := 0;
end.