{$I DEBUG}

{$IFDEF __BPREAL__}
{$A+,B-,D+,E+,F+,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,125000}
{$ELSE}
{$A+,B-,D+,E+,F+,G+,I-,L+,N+,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 64000}
{$ENDIF}

program Glitch;

uses Frames, VGAGraph, Objects, CRT, MapToRct, RStream, Credits,
     Flips, Crow, MJ, Kaleid, Reflex, Musax, Start, XGlitch, BW;

var
  I:		Integer;
  S:		String;
  Back:		TImage;
  Pages:	Word;
  SaveConfig:	Boolean;

begin
  if (DosMemAvail < 350000) then
  begin
    WriteLn( 'This demo requires at least 620K of free conventional memory.' );
    WriteLn( 'Try to use QEMM or EMM386 or another memory manager.' );
    Exit;
  end;
{$IFDEF __BPREAL__}
  Pages := 0;
  if (MemW[ 0: $67*4 ] <> 0) and (MemW[ 0: $67*4+2 ] <> 0) then
  begin
    asm
      mov ah,$42
      int $67
      mov Pages,bx
    end;
  end;
  if Pages < 32 then
  begin
    WriteLn( 'This demo requires at least 512K of free EMS memory for music.' );
    WriteLn( 'Running silence version, press any key to continue...' );
    ReadKey;
  end
  else
{$ENDIF}
  begin
    SaveConfig := False;
    for I := 1 to ParamCount do
      if ParamStr(I) = 'saveconfig' then SaveConfig := True;
    InitMusic( SaveConfig );
  end;
{$IFDEF DEBUG}

  Assign( MemF, 'MEM.LOG' );
  Rewrite( MemF );

{$ENDIF}
  InitFrames;
  SetMode13;
  FrameCount := 0;
{$IFDEF DEBUG}
  if ParamCount = 0 then
{$ENDIF}
    StartMusic( 'GLITCH.001' );
  LoadEMSCopy;
{  while FrameCount < 10 do;}

{$IFDEF DEBUG}
  if ParamCount > 0 then
  begin
    for I := 1 to ParamCount do
    begin
      S := ParamStr(I);
      case S[1] of
	'1':
	begin
	  if I = 1 then StartMusic( 'GLITCH.001' );
	  DoStart;
	  Back.Load( 'HANG1.NEW' );
	  PrepareCrow(Back.Data);
	  FlipShift( @Back );
	  Back.Done;
	  Back.Load( 'HANG1.NEW' );
	  DoCrow(Back.Data);
	  Back.Done;
	  DoReflex;
	end;
	'2':
	begin
	  if I = 1 then StartMusic( 'GLITCH.002' );
	  DoMJ;
	  DoKaleid;
	end;
	'3':
	begin
	  if I = 1 then StartMusic( 'GLITCH.003' );
	  DoXGlitch;
	  WriteLn( MemF, 'Credits Init' );
	  if Credits.Init then
	    Credits.Run;
	  Credits.Done;
	  WriteLn( MemF, 'Credits Done' );
	end;
      end;
    end;
  end
  else
{$ENDIF}
  begin
    DoStart;
    Back.Load( 'HANG1.NEW' );
    PrepareCrow(Back.Data);
    FrameCount := 0;
    FlipShift( @Back );
    while FrameCount < 100 do;
    Back.Done;
    Back.Load( 'HANG1.NEW' );
    DoCrow(Back.Data);
    Back.Done;
    DoReflex;
    DoBW( 'SIGNS.PCX' );
    StartMusic( 'GLITCH.002' );
    DoMJ;
    DoKaleid;
    DoBW( 'SIGNS.PCX' );
    StartMusic( 'GLITCH.003' );
    DoXGlitch;
{$IFDEF DEBUG}
    WriteLn( MemF, 'Credits Init' );
{$ENDIF}
    if Credits.Init then
      Credits.Run;
    Credits.Done;
{$IFDEF DEBUG}
    WriteLn( MemF, 'Credits Done' );
{$ENDIF}
  end;
  Abort;
end.