{$I DEBUG}
unit Gouraud;

interface

procedure DrawGouraudTriangle( X1,Y1, X2,Y2, X3,Y3,
			       Color1, Color2, Color3: Word;
			       Buffer: Pointer );

var
  Rnd:	array[ 0..255 ] of ShortInt;
  Err:	Byte;

implementation

uses VgaGraph;

procedure VLine( X, Y1, Y2, FromColor, ToColor: Byte ); assembler;
asm
  push cx
  xor ah,ah
  mov al,FromColor
  mov dx,ax
  mov al,ToColor
  mov bh,Y1
  mov bl,Y2
  cmp bh,bl
  je @exit
  jb @no_swap
  xchg bh,bl
  xchg ax,dx
@no_swap:
  mov si,dx
  sub ax,dx
  cwd
  shl ax,8
  xor ch,ch
  mov cl,bl
  sub cl,bh
  jz @exit
  cmp cx,1
  je @no_div1
  idiv cx
@no_div1:
  mov dx,ax
  mov bl,X
  add bx,di
  mov ax,si
  shl ax,8
  mov si,bx
@loop:
  mov es:[bx],ah
  add ax,dx
  inc bh
  dec cl
  jnz @loop
@exit:
  pop cx
end;

procedure DrawGouraudTriangle( X1,Y1, X2,Y2, X3,Y3,
			       Color1, Color2, Color3: Word;
			       Buffer: Pointer );
var
  YStep12,
  YStep23,
  YStep13,
  CStep12,
  CStep23,
  CStep13:	Integer;
  YT, YB,
  CT, CB:	Word;
  I:		Integer;
begin
  Err := 0;
  asm
    les di,Buffer
    mov ax,X1
    cmp ax,X2
    jbe @X2X3
    xchg ax,X2
    mov X1,ax
    push word ptr Y1
    push word ptr Y2
    pop word ptr Y1
    pop word ptr Y2
    push Color1
    push Color2
    pop Color1
    pop Color2
@X2X3:
    mov ax,X2
    cmp ax,X3
    jbe @Draw
    xchg ax,X3
    mov X2,ax
    push word ptr Y2
    push word ptr Y3
    pop word ptr Y2
    pop word ptr Y3
    push Color2
    push Color3
    pop Color2
    pop Color3
    cmp ax,X1
    ja @Draw
    xchg ax,X1
    mov X2,ax
    push word ptr Y1
    push word ptr Y2
    pop word ptr Y1
    pop word ptr Y2
    push Color1
    push Color2
    pop Color1
    pop Color2
@Draw:
    mov cx,X3
    sub cx,X1
    jz @exit
    xor al,al
    mov ah,byte ptr Y1
    mov YT,ax
    mov YB,ax
    mov ah,byte ptr Color1
    mov CT,ax
    mov CB,ax
    mov ax,Y3
    sub ax,Y1
    cwd
    shl ax,7
    cmp cx,1
    je @no_div1
    idiv cx
@no_div1:
    shl ax,1
    mov YStep13,ax
    mov ax,Color3
    sub ax,Color1
    cwd
    shl ax,7
    cmp cx,1
    je @no_div2
    idiv cx
@no_div2:
    shl ax,1
    mov CStep13,ax
    mov cx,X2
    sub cx,X1
    jz @part2
    mov ax,Y2
    sub ax,Y1
    cwd
    shl ax,7
    cmp cx,1
    je @no_div3
    idiv cx
@no_div3:
    shl ax,1
    mov YStep12,ax
    mov ax,Color2
    sub ax,Color1
    cwd
    shl ax,7
    cmp cx,1
    je @no_div4
    idiv cx
@no_div4:
    shl ax,1
    mov CStep12,ax
@loop1:
    push word ptr X1
    push word ptr YT+1
    push word ptr YB+1
    push word ptr CT+1
    push word ptr CB+1
    call VLine
    {VLine( byte ptr [X1+1], byte ptr [YT+1], byte ptr [YB+1],
	    byte ptr [CT+1], byte ptr [CB+1] );}
    mov ax,YStep12
    add YT,ax
    mov ax,YStep13
    add YB,ax
    mov ax,CStep12
    add CT,ax
    mov ax,CStep13
    add CB,ax
    inc X1
    loop @loop1
@part2:
    mov cx,X3
    sub cx,X2
    jz @exit
    xor al,al
    mov ah,byte ptr Y2
    mov YT,ax
    mov ah,byte ptr Color2
    mov CT,ax
    mov ax,Y3
    sub ax,Y2
    cwd
    shl ax,7
    cmp cx,1
    je @no_div5
    idiv cx
@no_div5:
    shl ax,1
    mov YStep23,ax
    mov ax,Color3
    sub ax,Color2
    cwd
    shl ax,7
    cmp cx,1
    je @no_div7
    idiv cx
@no_div7:
    shl ax,1
    mov CStep23,ax
@loop2:
    {VLine( byte ptr [X1+1], byte ptr [YT+1], byte ptr [YB+1],
	    byte ptr [CT+1], byte ptr [CB+1] );}

    push word ptr X1
    push word ptr YT+1
    push word ptr YB+1
    push word ptr CT+1
    push word ptr CB+1
    call VLine
    mov ax,YStep23
    add YT,ax
    mov ax,YStep13
    add YB,ax
    mov ax,CStep23
    add CT,ax
    mov ax,CStep13
    add CB,ax
    inc X1
    loop @loop2
@exit:
  end
end;

end.