{$I DEBUG}
unit Kaleid;

interface

procedure DoKaleid;

implementation

uses CRT, VgaGraph, MapToRct, Objects, Frames, Musax;

procedure DoKaleid;

const
  ColorOffset = 10;
  ColorShift = 0;
  Step1 = 700;
  TotalLength = Step1+100*2;
  Steps = 256;
  XStep = 0;
  YStep = 0;

var
  I, L:		Integer;
  TableX,
  TableY:	array[0..255] of Byte;
  StartTime,
  Pal:		TRGBPalette;
  X,Y:		Word;
  Buf:		Pointer;
  NLU,NRU,
  NRB,NLB,
  LU,RU,
  RB,LB:	TPoint;
  ToR:		TRect;
  IAngle:	Integer;
  Angle:	Real;
  K, KMul:	Real;
  _DX:		Word;
  Tmp:		Byte;
  VScreen:	Pointer;
  WhitePal:	TRGBPalette;

begin
  Buf := DosAllocMem(65536);
  VScreen := DosAllocMem( 64000 );
  LU.X := -160; LU.Y := -100;
  RU.X := 160; RU.Y := -100;
  LB.X := -160; LB.Y := 100;
  RB.X := 160; RB.Y := 100;
  Angle := 1;
  ToR.A.X := 0;
  ToR.A.Y := 0;
  ToR.B.X := 319;
  ToR.B.Y := 199;
  K := 20; KMul := 1.05;
  FillChar( Pal, SizeOf(Pal), 0 );
  FillChar( WhitePal, SizeOf(Pal), 63 );
{
  for I := 0 to 127 do
  begin
    Pal[I].R := I shr 1;
    Pal[I].G := I shr 1;
    Pal[I].B := I shr 1;
    Pal[255-I] := Pal[I];
  end;
}

  for I := 0 to 63 do
  begin
    Inc( Pal[I].R, I shr 1);
    Inc( Pal[128-I].R, I shr 0 );

    Inc( Pal[I+64].B, I shr 1 );
    Inc( Pal[192-I].B, I shr 0 );
    Inc( Pal[I+64].G, I shr 1);
    Inc( Pal[192-I].G, I shr 1 );

    Inc( Pal[I+128].G, I shr 1);
    Inc( Pal[256-I].G, I shr 0 );
    Inc( Pal[I+128].R, I shr 1);
    Inc( Pal[256-I].R, I shr 1 );
  end;

  Pal[64] := Pal[63];
  Pal[128] := Pal[127];
  Pal[192] := Pal[191];

  SetPalette( @Pal );
  Randomize;
  FrameCount := 0;
  IAngle := 0;
  I := FrameCount;
  while FrameCount < TotalLength do
  begin
    Y := Random(128);
    X := Random(Y);
    Mem[ Seg(Buf^) : (Y shl 8 + X) ] := ColorOffset+Random(256-ColorOffset);
    asm
      mov dx,_dx
      push ds
      lds bx,Buf
      xor bx,bx
@loop_x:
      mov al,[bx]

      cmp al,ColorOffset
      jb @next

      dec al
      mov [bx-1],al
      mov [bx+1],al
      dec al
      mov [bx-256],al
      mov [bx+256],al
      mov [bx],al

      neg bh
      mov [bx],al
      neg bl
      mov [bx],al
      neg bh
      mov [bx],al
      neg bl
      xchg bl,bh
      mov [bx],al
      neg bh
      mov [bx],al
      neg bl
      mov [bx],al
      neg bh
      mov [bx],al
      neg bl
      xchg bl,bh
@next:
      add bx,dx
      inc dx
      test dx,$4000-1
      jnz @loop_x
      pop ds
      mov _dx,dx
    end;

    if I < 120 then
    begin
      if FrameCount-I >= 20 then
      begin
	K := K/1.6;
	SetPalette(@WhitePal);
	WaitNextFrame;
	SetPalette(@Pal);
	Inc(I,20);
      end;
    end
    else
    begin
      Inc(IAngle);
    end;
{    K := K*KMul;}
    Angle := Sin(IAngle*2*Pi/Steps)*Steps;
    Inc(LU.X,XStep);
    Inc(LU.Y,YStep);
    Inc(RU.X,XStep);
    Inc(RU.Y,YStep);
    Inc(LB.X,XStep);
    Inc(LB.Y,YStep);
    Inc(RB.X,XStep);
    Inc(RB.Y,YStep);
{
    Dec(LU.X);
    Inc(RU.X);
}
    if FrameCount > Step1 then
    begin
      ToR.A.X := (FrameCount-Step1) div 2;
      ToR.A.Y := (FrameCount-Step1) div 2;
      ToR.B.X := 320-(FrameCount-Step1) div 2;
      ToR.B.Y := 200-(FrameCount-Step1) div 2;
    end;
{
    if (FrameCount < Step1) and (FrameCount > 120) and (Random(40) = 0) then
    begin
      RB.X := -160;
      RB.Y := -100;
    end;
    if (FrameCount < Step1) and (FrameCount > 120) and (Random(20) = 0) then
    begin
      RB.X := 160;
      RB.Y := 100;
    end;
}
    if (K > 3.7) or (K<0.5) then  KMul := 2-KMul;
    NRU.Y := Round( K*((RU.Y*Cos(2*Pi/Steps*Angle)-RU.X*Sin(2*Pi/Steps*Angle))) );
    NRU.X := Round( K*(((RU.X*Cos(2*Pi/Steps*Angle)+RU.Y*Sin(2*Pi/Steps*Angle)))) );
    NLU.Y := Round( K*((LU.Y*Cos(2*Pi/Steps*Angle)-LU.X*Sin(2*Pi/Steps*Angle))) );
    NLU.X := Round( K*(((LU.X*Cos(2*Pi/Steps*Angle)+LU.Y*Sin(2*Pi/Steps*Angle)))) );
    NRB.Y := Round( K*((RB.Y*Cos(2*Pi/Steps*Angle)-RB.X*Sin(2*Pi/Steps*Angle))) );
    NRB.X := Round( K*(((RB.X*Cos(2*Pi/Steps*Angle)+RB.Y*Sin(2*Pi/Steps*Angle)))) );
    NLB.Y := Round( K*((LB.Y*Cos(2*Pi/Steps*Angle)-LB.X*Sin(2*Pi/Steps*Angle))) );
    NLB.X := Round( K*(((LB.X*Cos(2*Pi/Steps*Angle)+LB.Y*Sin(2*Pi/Steps*Angle)))) );
    if KeyPressed then Abort;
    WaitRetrace;
    MapPicToRect( NLU,NRU,NRB,NLB, ToR, Buf, Screen );
{    SmoothPage( VScreen, Screen );}
{    CopyPage( VScreen, Screen );}
    if Random( ColorShift ) > 0 then
    begin
      Tmp := Pal[1].R;
      for L := 2 to 255 do
	Pal[L-1].R := Pal[L].R;
      Pal[255].R := Tmp;
    end;
    if Random( ColorShift ) > 0 then
    begin
      Tmp := Pal[1].B;
      for L := 2 to 255 do
	Pal[L-1].B := Pal[L].B;
      Pal[255].B := Tmp;
    end;
    if Random( ColorShift ) > 0 then
    begin
      Tmp := Pal[1].G;
      for L := 2 to 255 do
	Pal[L-1].G := Pal[L].G;
      Pal[255].G := Tmp;
    end;
    SetPalette(@Pal);
    if FrameCount > TotalLength-64 then
    begin
      SetVolume( TotalLength-FrameCount );
    end;
  end;
  DosFreeMem(Buf);
  DosFreeMem(VScreen);
end;

end.
