{$I DEBUG}
unit MapToRct;

interface

uses Objects;

procedure MapPicToRect( LU,RU,RB,LB:TPoint; ToR: TRect; Pic, Screen: Pointer );
procedure MapPicToRectAdd( LU,RU,RB,LB:TPoint; ToR: TRect; Pic, Screen: Pointer );
procedure MapRectToPic( LU,RU,RB,LB:TPoint; Pic, Screen: Pointer );
procedure MapRectToPic64( LU,RU,RB,LB:TPoint; Pic, Screen: Pointer );

implementation

uses VGAGraph;

type
  TLong = record
	    case Word of
	      0:(Lo,Hi: Word);
	      1:(Long: LongInt);
	  end;

procedure MapPicToRect( LU,RU,RB,LB:TPoint; ToR: TRect; Pic, Screen: Pointer );
var
  LX,LY,
  RX,RY:	TLong;
  Offs,
  AddX,
  HSize,
  VSize:	Word;
  XLStep,
  YLStep,
  XRStep,
  YRStep:	LongInt;
  Tmp:		Integer;
begin
  with ToR do
  begin
    if A.X > B.X then
    begin
      Tmp := A.X; A.X := B.X; B.X := Tmp;
    end;
    if A.Y > B.Y then
    begin
      Tmp := A.Y; A.Y := B.Y; B.Y := Tmp;
    end;
    Offs := HRes*A.Y+A.X;
    HSize := B.X-A.X+1;
    AddX := HRes - HSize;
    VSize := B.Y-A.Y+1;
  end;
  XLStep := LongInt(LB.X-LU.X) shl 16 div VSize;
  YLStep := LongInt(LB.Y-LU.Y) shl 16 div VSize;
  XRStep := LongInt(RB.X-RU.X) shl 16 div VSize;
  YRStep := LongInt(RB.Y-RU.Y) shl 16 div VSize;
  LX.Hi := LU.X; LY.Hi := LU.Y;
  LX.Lo := 0; LY.Lo := 0;
  RX.Hi := RU.X; RY.Hi := RU.Y;
  RX.Lo := 0; RY.Lo := 0;
  asm
    push ds
    les di,Screen
    lds bx,Pic
    mov di,Offs
    mov cx,VSize
@y_loop:
    push bp
    push cx
    mov cx,HSize
    mov ax,RX.Hi
    sub ax,LX.Hi
    cwd
    mov dl,ah
    shl ax,8
    idiv HSize
    push ax
    mov ax,RY.Hi
    sub ax,LY.Hi
    cwd
    mov dl,ah
    shl ax,8
    idiv HSize
    push ax
    mov ah,byte ptr LX.Hi
    xor al,al
    mov si,LY.Hi
    shl si,8
    pop bp
    pop dx
@x_loop:
    mov bx,si
    mov bl,ah
    mov bl,byte ptr [bx]
    mov es:[di],bl
    inc di
    add ax,dx
    add si,bp
    dec cx
    jnz @x_loop
    pop cx
    pop bp
    add di,AddX
    db $66; mov ax,word ptr XLStep
    db $66; add word ptr LX,ax
    db $66; mov ax,word ptr XRStep
    db $66; add word ptr RX,ax
    db $66; mov ax,word ptr YLStep
    db $66; add word ptr LY,ax
    db $66; mov ax,word ptr YRStep
    db $66; add word ptr RY,ax
    loop @y_loop
    pop ds
  end;
end;

procedure MapPicToRectAdd( LU,RU,RB,LB:TPoint; ToR: TRect; Pic, Screen: Pointer );
var
  LX,LY,
  RX,RY:	TLong;
  Offs,
  AddX,
  HSize,
  VSize:	Word;
  XLStep,
  YLStep,
  XRStep,
  YRStep:	LongInt;
  Tmp:		Integer;
begin
  with ToR do
  begin
    if A.X > B.X then
    begin
      Tmp := A.X; A.X := B.X; B.X := Tmp;
    end;
    if A.Y > B.Y then
    begin
      Tmp := A.Y; A.Y := B.Y; B.Y := Tmp;
    end;
    Offs := HRes*A.Y+A.X;
    HSize := B.X-A.X+1;
    AddX := HRes - HSize;
    VSize := B.Y-A.Y+1;
  end;
  XLStep := LongInt(LB.X-LU.X) shl 16 div VSize;
  YLStep := LongInt(LB.Y-LU.Y) shl 16 div VSize;
  XRStep := LongInt(RB.X-RU.X) shl 16 div VSize;
  YRStep := LongInt(RB.Y-RU.Y) shl 16 div VSize;
  LX.Hi := LU.X; LY.Hi := LU.Y;
  LX.Lo := 0; LY.Lo := 0;
  RX.Hi := RU.X; RY.Hi := RU.Y;
  RX.Lo := 0; RY.Lo := 0;
  asm
    push ds
    les di,Screen
    lds bx,Pic
    mov di,Offs
    mov cx,VSize
@y_loop:
    push bp
    push cx
    mov cx,HSize
    mov ax,RX.Hi
    sub ax,LX.Hi
    cwd
    mov dl,ah
    shl ax,8
    idiv HSize
    push ax
    mov ax,RY.Hi
    sub ax,LY.Hi
    cwd
    mov dl,ah
    shl ax,8
    idiv HSize
    push ax
    mov ah,byte ptr LX.Hi
    xor al,al
    mov si,LY.Hi
    shl si,8
    pop bp
    pop dx
@x_loop:
    mov bx,si
    mov bl,ah
    mov bl,byte ptr [bx]
    add es:[di],bl
    inc di
    add ax,dx
    add si,bp
    dec cx
    jnz @x_loop
    pop cx
    pop bp
    add di,AddX
    db $66; mov ax,word ptr XLStep
    db $66; add word ptr LX,ax
    db $66; mov ax,word ptr XRStep
    db $66; add word ptr RX,ax
    db $66; mov ax,word ptr YLStep
    db $66; add word ptr LY,ax
    db $66; mov ax,word ptr YRStep
    db $66; add word ptr RY,ax
    loop @y_loop
    pop ds
  end;
end;

procedure MapRectToPic64( LU,RU,RB,LB:TPoint; Pic, Screen: Pointer );
var
  LX,LY,
  RX,RY:	Word;
  Offs,
  AddX,
  HSize,
  VSize:	Word;
  XLStep,
  YLStep,
  XRStep,
  YRStep:	Word;
  Tmp:		Integer;
  TmpP,
  P1, P2,
  P3, P4:	TPoint;
  XR, XL,
  XLOfs,
  XROfs:	LongInt;
  _VRes,
  _Hres:	Word;
  LFlag,
  RFlag:	Word;
  CurY:		Integer;
{
  I:		Integer;
type
  TMulTable= array[0..255] of Word;
const
  MulTable:	^TMulTable = nil;
}
begin
  LFlag := 0; RFlag := 0;
  P1.X := 0; P1.Y := 0;
  P2.X := 63; P2.Y := 0;
  P3.X := 63; P3.Y := 63;
  P4.X := 0; P4.Y := 63;
  while (LU.Y > RU.Y) or (LU.Y > LB.Y) do
  begin
    TmpP := LU; LU := RU; RU := RB; RB := LB; LB := TmpP;
    TmpP := P1; P1 := P2; P2 := P3; P3 := P4; P4 := TmpP;
  end;
  LX := P1.X shl 8; LY := P1.Y shl 8;
  RX := P1.X shl 8; RY := P1.Y shl 8;
  XR := LongInt(LU.X) shl 16;
  XL := XR;
  CurY := LU.Y;
  Offs := HRes*LU.Y;
  _HRes := HRes; _VRes := VRes;
{
  if MulTable = nil then MulTable := DosAllocMem( SizeOf(TMulTable) );
  for I := 0 to 255 do
    MulTable^[I] := I*64;
}
  asm
    push ds
    les di,Screen
    {lfs bx,MulTable}
    {db $0F,$B4,$1E,$02,$00}
    mov di,Offs
    lds si,Pic
    xor cx,cx
    mov ax,P2.Y
    sub ax,P1.Y
    db $66; xor bx,bx
    mov bx,RU.Y
    sub bx,LU.Y
    jz @no_R1
    mov cl,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div6
    idiv bx
@no_div6:
    mov word ptr YRStep,ax
    mov ax,P2.X
    sub ax,P1.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div5
    idiv bx
@no_div5:
    mov XRStep,ax
    mov ax,RU.X
    sub ax,LU.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XROfs,ax
@no_R1:
    mov ax,P4.Y
    sub ax,P1.Y
    db $66; xor bx,bx
    mov bx,LB.Y
    sub bx,LU.Y
    jz @no_L1
    mov ch,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div9
    idiv bx
@No_div9:
    mov word ptr YLStep,ax
    mov ax,P4.X
    sub ax,P1.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div1
    idiv bx
@no_div1:
    mov XLStep,ax
    mov ax,LB.X
    sub ax,LU.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XLOfs,ax
@no_L1:
@y_loop:
    or cl,cl
    jnz @no_new_R
    cmp RFlag,0
    jne @new_R2
    mov RFlag,1
    mov ax,P3.Y
    sub ax,P2.Y
    db $66; xor bx,bx
    mov bx,RB.Y
    sub bx,RU.Y
    jz @exit
    mov cl,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div10
    idiv bx
@no_div10:
    mov word ptr YRStep,ax
    mov ax,P3.X
    sub ax,P2.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div2
    idiv bx
@no_div2:
    mov XRStep,ax
    mov ax,RB.X
    sub ax,RU.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XROfs,ax
    mov ax,P2.X
    mov RX,ax
    shl RX,8
    mov ax,P2.Y
    mov RY,ax
    shl RY,8
    mov ax,RU.X
    db $66; shl ax,16
    db $66; mov word ptr XR,ax
    jmp @no_new_R
@new_R2:
    mov ax,P4.Y
    sub ax,P3.Y
    db $66; xor bx,bx
    mov bx,LB.Y
    sub bx,RB.Y
    mov cl,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div11
    idiv bx
@no_div11:
    mov word ptr YRStep,ax
    mov ax,P4.X
    sub ax,P3.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div7
    idiv bx
@no_div7:
    mov XRStep,ax
    mov ax,LB.X
    sub ax,RB.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XROfs,ax
    mov ax,P3.X
    mov RX,ax
    shl RX,8
    mov ax,P3.Y
    mov RY,ax
    shl RY,8
    mov ax,RB.X
    db $66; shl ax,16
    db $66; mov word ptr XR,ax
@no_new_R:
    or ch,ch
    jnz @no_new_L
    cmp LFlag,0
    jne @new_L2
    mov LFlag,1
    mov ax,P3.Y
    sub ax,P4.Y
    db $66; xor bx,bx
    mov bx,RB.Y
    sub bx,LB.Y
    mov ch,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div8
    idiv bx
@no_div8:
    mov word ptr YLStep,ax
    mov ax,P3.X
    sub ax,P4.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div4
    idiv bx
@no_div4:
    mov XLStep,ax
    mov ax,RB.X
    sub ax,LB.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XLOfs,ax
    mov ax,P4.X
    mov LX,ax
    shl LX,8
    mov ax,P4.Y
    mov LY,ax
    shl LY,8
    mov ax,LB.X
    db $66; shl ax,16
    db $66; mov word ptr XL,ax
    jmp @no_new_L
@new_L2:
    mov ax,P2.Y
    sub ax,P3.Y
    db $66; xor bx,bx
    mov bx,RU.Y
    sub bx,RB.Y
    jz @exit
    mov ch,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div12
    idiv bx
@no_div12:
    mov YLStep,ax
    mov ax,P2.X
    sub ax,P3.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div3
    idiv bx
@no_div3:
    mov XLStep,ax
    mov ax,RU.X
    sub ax,RB.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XLOfs,ax
    mov ax,P3.X
    mov LX,ax
    shl LX,8
    mov ax,P3.Y
    mov LY,ax
    shl LY,8
    mov ax,RB.X
    db $66; shl ax,16
    db $66; mov word ptr XL,ax
@no_new_L:
      test byte ptr CurY,$80
      jnz @new_line
      mov ax,_VRes
      cmp word ptr CurY,ax
      jge @exit
      push di
      push bp
      push cx
      db $66; mov cx,word ptr XR
      db $66; cmp cx,word ptr XL
      jae @no_swap
      db $66; xchg cx,word ptr XL
      db $66; mov word ptr XR,cx
{
      mov ax,word ptr RX
      xchg ax,word ptr LX
      mov word ptr RX,ax
      mov ax,word ptr RY
      xchg ax,word ptr LY
      mov word ptr RY,ax
}
@no_swap:
      db $66; sub cx,word ptr XL
      db $66; shr cx,16
      jz @next_line
      add di,word ptr XL+2
      {movzx ax,byte ptr RX+1}
      db $0F,$B6,$86; dw offset RX+1
      {movzx bx,byte ptr LX+1}
      db $0F,$B6,$9E; dw offset LX+1
      sub ax,bx
      cwd
      shl ax,8
      idiv cx
      push ax
      {movzx ax,byte ptr RY+1}
      db $0F,$B6,$86; dw offset RY+1
      {movzx bx,byte ptr LY+1}
      db $0F,$B6,$9E; dw offset LY+1
      sub ax,bx
      cwd
      shl ax,8
      idiv cx
      push ax
      mov ah,byte ptr LX+1
      xor al,al
      mov si,LY
      pop bp
      pop dx
@x_loop:
(*
	{movzx ebx,ah}
	db $66,$0F,$B6,$DC
	{mov bx,fs:[ebx*2]}
	db $64,$67,$8B,$1C,$5D,0,0,0,0
	add bx,si
	xchg bl,bh
*)
	mov bx,si
	mov bl,ah

	shl bl,2
	shr bx,2
	and bh,00001111b

	mov bl,byte ptr [bx]
{
	or bl,bl
	jz @no_draw
}
	mov es:[di],bl
@no_draw:
	inc di
	add ax,dx
	add si,bp
	dec cx
	jnz @x_loop
@next_line:
    pop cx
    pop bp
    pop di
@new_line:
    add di,_HRes
    mov ax,word ptr XLStep
    add word ptr LX,ax
    mov ax,word ptr XRStep
    add word ptr RX,ax
    mov ax,word ptr YLStep
    add word ptr LY,ax
    mov ax,word ptr YRStep
    add word ptr RY,ax
    db $66; mov ax,word ptr XROfs
    db $66; add word ptr XR,ax
    db $66; mov ax,word ptr XLOfs
    db $66; add word ptr XL,ax
    dec cl
    dec ch
    or cx,cx
    jnz @y_loop
@exit:
    pop ds
  end;
end;

procedure MapRectToPic( LU,RU,RB,LB:TPoint; Pic, Screen: Pointer );
var
  LX,LY,
  RX,RY:	Word;
  Offs,
  AddX,
  HSize,
  VSize:	Word;
  XLStep,
  YLStep,
  XRStep,
  YRStep:	Word;
  XLStep2,
  YLStep2,
  XRStep2,
  YRStep2:	Word;
  Tmp:		Integer;
  TmpP,
  P1, P2,
  P3, P4:	TPoint;
  XR, XL,
  XLOfs,
  XROfs:	LongInt;
  _VRes,
  _Hres:	Word;
  LFlag,
  RFlag:	Word;
  CurY:		Integer;
  Tmp1,
  Tmp2:		Word;
  _bp:		Word;
  Swap:		Byte;
{
  I:		Integer;
type
  TMulTable= array[0..255] of Word;
const
  MulTable:	^TMulTable = nil;
}
begin
  Swap := 0;
  LFlag := 0; RFlag := 0;
  P1.X := 0; P1.Y := 0;
  P2.X := 255; P2.Y := 0;
  P3.X := 255; P3.Y := 255;
  P4.X := 0; P4.Y := 255;
  while (LU.Y > RU.Y) or (LU.Y > LB.Y) do
  begin
    TmpP := LU; LU := RU; RU := RB; RB := LB; LB := TmpP;
    TmpP := P1; P1 := P2; P2 := P3; P3 := P4; P4 := TmpP;
  end;
  LX := P1.X shl 8; LY := P1.Y shl 8;
  RX := P1.X shl 8; RY := P1.Y shl 8;
  XR := LongInt(LU.X) shl 16;
  XL := XR;
  CurY := LU.Y;
  Offs := HRes*LU.Y;
  _HRes := HRes; _VRes := VRes;
  XLStep := 0;  YLStep := 0;
  XRStep := 0;  YRStep := 0;
{
  if MulTable = nil then MulTable := DosAllocMem( SizeOf(TMulTable) );
  for I := 0 to 255 do
    MulTable^[I] := I*64;
}
  asm
    push ds
    les di,Screen
    {lfs bx,MulTable}
    {db $0F,$B4,$1E,$02,$00}
    mov di,Offs
    lds si,Pic
    xor cx,cx
    db $66; xor bx,bx
    mov bx,RU.Y
    sub bx,LU.Y
    jz @no_R1
    mov cl,bl
    mov ax,P2.Y
    sub ax,P1.Y
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div6
    idiv bx
@no_div6:
    mov word ptr YRStep,ax
    mov ax,P2.X
    sub ax,P1.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div5
    idiv bx
@no_div5:
    mov XRStep,ax
{    db $66; pop bx}
    mov ax,RU.X
    sub ax,LU.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XROfs,ax
@no_R1:
    mov ax,P4.Y
    sub ax,P1.Y
    db $66; xor bx,bx
    mov bx,LB.Y
    sub bx,LU.Y
    jz @no_L1
    mov ch,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div9
    idiv bx
@No_div9:
    mov word ptr YLStep,ax
    mov ax,P4.X
    sub ax,P1.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div1
    idiv bx
@no_div1:
    mov XLStep,ax
    mov ax,LB.X
    sub ax,LU.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XLOfs,ax
@no_L1:
@y_loop:
    or cl,cl
    jnz @no_new_R
    cmp RFlag,0
    jne @new_R2
    mov RFlag,1
    mov ax,P3.Y
    sub ax,P2.Y
    db $66; xor bx,bx
    mov bx,RB.Y
    sub bx,RU.Y
    jz @exit
    mov cl,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div10
    idiv bx
@no_div10:
    mov word ptr YRStep,ax
    mov ax,P3.X
    sub ax,P2.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div2
    idiv bx
@no_div2:
    mov XRStep,ax
    mov ax,RB.X
    sub ax,RU.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XROfs,ax
    mov ax,P2.X
    mov RX,ax
    shl RX,8
    mov ax,P2.Y
    mov RY,ax
    shl RY,8
    mov ax,RU.X
    db $66; shl ax,16
    db $66; mov word ptr XR,ax
    jmp @no_new_R
@new_R2:
    mov ax,P4.Y
    sub ax,P3.Y
    db $66; xor bx,bx
    mov bx,LB.Y
    sub bx,RB.Y
    mov cl,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div11
    idiv bx
@no_div11:
    mov word ptr YRStep,ax
    mov ax,P4.X
    sub ax,P3.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div7
    idiv bx
@no_div7:
    mov XRStep,ax
    mov ax,LB.X
    sub ax,RB.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XROfs,ax
    mov ax,P3.X
    mov RX,ax
    shl RX,8
    mov ax,P3.Y
    mov RY,ax
    shl RY,8
    mov ax,RB.X
    db $66; shl ax,16
    db $66; mov word ptr XR,ax
@no_new_R:
    or ch,ch
    jnz @no_new_L
    cmp LFlag,0
    jne @new_L2
    mov LFlag,1
    mov ax,P3.Y
    sub ax,P4.Y
    db $66; xor bx,bx
    mov bx,RB.Y
    sub bx,LB.Y
    mov ch,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div8
    idiv bx
@no_div8:
    mov word ptr YLStep,ax
    mov ax,P3.X
    sub ax,P4.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div4
    idiv bx
@no_div4:
    mov XLStep,ax
    mov ax,RB.X
    sub ax,LB.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XLOfs,ax
    mov ax,P4.X
    mov LX,ax
    shl LX,8
    mov ax,P4.Y
    mov LY,ax
    shl LY,8
    mov ax,LB.X
    db $66; shl ax,16
    db $66; mov word ptr XL,ax
    jmp @no_new_L
@new_L2:
    mov ax,P2.Y
    sub ax,P3.Y
    db $66; xor bx,bx
    mov bx,RU.Y
    sub bx,RB.Y
    jz @exit
    mov ch,bl
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div12
    idiv bx
@no_div12:
    mov YLStep,ax
    mov ax,P2.X
    sub ax,P3.X
    cwd
    mov dl,ah
    shl ax,8
    cmp bx,1
    je @no_div3
    idiv bx
@no_div3:
    mov XLStep,ax
    mov ax,RU.X
    sub ax,RB.X
    db $66; shl ax,16
    db $66; cwd
    db $66; idiv bx
    db $66; mov word ptr XLOfs,ax
    mov ax,P3.X
    mov LX,ax
    shl LX,8
    mov ax,P3.Y
    mov LY,ax
    shl LY,8
    mov ax,RB.X
    db $66; shl ax,16
    db $66; mov word ptr XL,ax
@no_new_L:

      test word ptr CurY,$8000
      jnz @new_line
      mov ax,_VRes
      cmp word ptr CurY,ax
      jge @exit

      push di
      push cx
      push bp
      db $66; mov cx,word ptr XR
      db $66; cmp cx,word ptr XL
      jge @no_swap
      xor Swap,1
      db $66; xchg cx,word ptr XL
      db $66; mov word ptr XR,cx
      mov ax,RX
      xchg ax,LX
      mov RX,ax
      mov ax,RY
      xchg ax,LY
      mov RY,ax
@no_swap:
      add di,word ptr XL+2

      db $66; shr cx,16
      sub cx,word ptr XL+2
      jz @next_line

      {movzx ax,byte ptr RX+1}
      db $0F,$B6,$86; dw offset RX+1
      {movzx bx,byte ptr LX+1}
      db $0F,$B6,$9E; dw offset LX+1
      sub ax,bx
      cwd
      shl ax,8
      cmp cx,1
      jne @div1
      xor ax,ax
      jmp @no_div13
@div1:
      idiv cx
@no_div13:
      push ax
      {movzx ax,byte ptr RY+1}
      db $0F,$B6,$86; dw offset RY+1
      {movzx bx,byte ptr LY+1}
      db $0F,$B6,$9E; dw offset LY+1
      sub ax,bx
      cwd
      shl ax,8
      cmp cx,1
      je @no_div14
      or cx,cx
      jnz @div2
      xor ax,ax
      jmp @no_div14
@div2:
      idiv cx
@no_div14:
      mov _bp,ax
      mov ah,byte ptr LX+1
      xor al,al
      mov si,LY
      pop dx

      test word ptr XL+2,$8000
      jz @no_l_clip

      push ax
      mov bx,dx
      mov ax,word ptr XL+2
      neg ax
      sub cx,ax
      jnz @still_draw
      pop ax
      jmp @next_line
@still_draw:
      add di,ax
      xor dx,dx
      push ax
      mul bx
      mov Tmp1,ax
      pop ax
      mul _bp
      add si,ax
@what_the_hell:
      pop ax
      add ax,Tmp1
      mov dx,bx

@no_l_clip:
      mov bx,_HRes
      sub bx,word ptr XR+2
      jg @no_r_clip
      add cx,bx
@no_r_clip:
      mov bp,_bp
@x_loop:
(*
	{movzx ebx,ah}
	db $66,$0F,$B6,$DC
	{mov bx,fs:[ebx*2]}
	db $64,$67,$8B,$1C,$5D,0,0,0,0
	add bx,si
	xchg bl,bh
*)
	mov bx,si
	mov bl,ah
{
	shl bl,2
	shr bx,2
	and bh,00001111b
}
	mov bl,byte ptr [bx]

	or bl,bl
	jz @no_draw

	mov es:[di],bl
@no_draw:
	inc di
	add ax,dx
	add si,bp
	dec cx
	jnz @x_loop
@next_line:
    pop bp
    pop cx
    pop di
@new_line:
    test Swap,1
    jz @no_swap1
    db $66; mov ax,word ptr XL
    db $66; xchg ax,word ptr XR
    db $66; mov word ptr XL,ax
    mov ax,RX
    xchg ax,LX
    mov RX,ax
    mov ax,RY
    xchg ax,LY
    mov RY,ax
    xor Swap,1
@no_swap1:
    inc word ptr CurY
    add di,_HRes

    mov ax,word ptr XLStep
    add word ptr LX,ax
{
    add ax,word ptr XLStep2
    mov XLStep,ax
}
    mov ax,word ptr XRStep
    add word ptr RX,ax
{
    add ax,word ptr XRStep2
    mov XRStep,ax
}
    mov ax,word ptr YLStep
    add word ptr LY,ax
{
    add ax,word ptr YLStep2
    mov YLStep,ax
}
    mov ax,word ptr YRStep
    add word ptr RY,ax
{
    add ax,word ptr YRStep2
    mov YRStep,ax
}
    db $66; mov ax,word ptr XROfs
    db $66; add word ptr XR,ax
    db $66; mov ax,word ptr XLOfs
    db $66; add word ptr XL,ax
    dec cl
    dec ch
    or cx,cx
    jnz @y_loop
@exit:
    pop ds
  end;
end;

end.