{$I DEBUG}
unit MJ;

interface

procedure DoMJ;

implementation

uses Poly2D, VGAGraph, MapToRct, Objects, CRT, Frames, Fonts, Musax;

const
  LineCount = 10;
  MorphSteps = 40;
  RotSteps = 60;
  Steps = 64;
  XStep = 0;
  YStep = 0;
  MaxText = 9;
  Text : array[0..MaxText] of String = (
    'ENJOY',
    'STONED',
    'FREE',
    'NEVERMIND',
    'MJ',
    'MAGIC',
    'LOVE',
    'ROCK',
    'BLOOD',
    'MISTERY'
   );

procedure DrawHLineGr( Y, X1, X2: Integer; Color: Byte; Buffer: Pointer );
begin
  if (Y < VRes) or (Y >= 0) then
  begin
    asm
      mov ax,X1
      mov cx,X2
      cmp ax,cx
      jle @no_swap
      xchg ax,cx
@no_swap:
      cmp ax,0
      jge @no_l
      xor ax,ax
@no_l:
      cmp ax,HRes
      jge @exit
      cmp cx,HRes
      jl @no_r
      mov cx,HRes
      dec cx
@no_r:
      cmp cx,0
      jl @exit
      sub cx,ax
      inc cx
      les di,Buffer
      mov di,ax
      mov ax,HRes
      mul Y
      add di,ax
      mov ah,128+64
      sub ah,Color
      xor al,al
      shr cx,1
      jcxz @exit
      div cx
      mov bx,ax
      mov ah,Color
      push cx
@loop1:
      add es:[di],ah
      inc di
      add ax,bx
      loop @loop1
      pop cx
@loop2:
      add es:[di],ah
      inc di
      sub ax,bx
      loop @loop2
@exit:
    end;
  end;
end;

const
  PDrawHLineGr : Pointer = @DrawHLineGr;

procedure DoMJ;
var
  MJ, Tmp,
  MJ1, MJ2:	PPoly2D;
  VScreen:	Pointer;
  Smoke:	TImage;
  I,J:		Integer;
  NLU,NRU,
  NRB,NLB,
  LU,RU,
  RB,LB:	TPoint;
  ToR:		TRect;
  Angle:	Integer;
  K, KMul:	Real;
  CurPal,
  Pal:		TRGBPalette;
  Font:		TFont;
  Prev:		LongInt;
  Words:	array[0..MaxText] of PImage;
  Line:		PImage;
  P:		Pointer;
  H:		Integer;
  MJName:	String;

procedure DoLine;
var
  N:		Integer;
  Origin:	TPoint;

begin
  CurPal[255].R := Random(64);
  CurPal[255].G := Random(64);
  CurPal[255].B := Random(64);
  for N := 1 to 15 do
  begin
    CurPal[240+N].R := Integer(CurPal[255].R)*N div 16;
    CurPal[240+N].G := Integer(CurPal[255].G)*N div 16;
    CurPal[240+N].B := Integer(CurPal[255].B)*N div 16;
  end;
  repeat
    N := Random(MaxText);
  until Words[N] <> nil;
  Origin.X := Random(HRes-Words[N]^.Size.X);
  Origin.Y := Random(VRes-Words[N]^.Size.Y);
  Words[N]^.ShowAddConstT( Origin, VScreen, 240 );
  SetPalette(@CurPal);
end;

procedure DoBack;
begin
  K := K*KMul;
  Inc(Angle);
  Inc(LU.X,XStep);
  Inc(LU.Y,YStep);
  Inc(RU.X,XStep);
  Inc(RU.Y,YStep);
  Inc(LB.X,XStep);
  Inc(LB.Y,YStep);
  Inc(RB.X,XStep);
  Inc(RB.Y,YStep);
{  WriteLn( MemF, 'K = ', K:5:2, ' I=',I, ' J=',J );}
{      if (K > 1) or (K<0.5) then  KMul := 2-KMul;}
  NRU.Y := Round( K*((RU.Y*Cos(2*Pi/Steps*Angle)-RU.X*Sin(2*Pi/Steps*Angle))) );
  NRU.X := Round( K*(((RU.X*Cos(2*Pi/Steps*Angle)+RU.Y*Sin(2*Pi/Steps*Angle)))) );
  NLU.Y := Round( K*((LU.Y*Cos(2*Pi/Steps*Angle)-LU.X*Sin(2*Pi/Steps*Angle))) );
  NLU.X := Round( K*(((LU.X*Cos(2*Pi/Steps*Angle)+LU.Y*Sin(2*Pi/Steps*Angle)))) );
  NRB.Y := Round( K*((RB.Y*Cos(2*Pi/Steps*Angle)-RB.X*Sin(2*Pi/Steps*Angle))) );
  NRB.X := Round( K*(((RB.X*Cos(2*Pi/Steps*Angle)+RB.Y*Sin(2*Pi/Steps*Angle)))) );
  NLB.Y := Round( K*((LB.Y*Cos(2*Pi/Steps*Angle)-LB.X*Sin(2*Pi/Steps*Angle))) );
  NLB.X := Round( K*(((LB.X*Cos(2*Pi/Steps*Angle)+LB.Y*Sin(2*Pi/Steps*Angle)))) );
  MapPicToRect( NLU,NRU,NRB,NLB, ToR, Smoke.Data, VScreen );
end;

begin
  FrameCount := 0;
  Prev := 0;
  Randomize;
  Font.Load('STAMP36.FNT');
  Smoke.Load('MJ_BACK.PCX');
  New( MJ, Init(@PDrawHLineGr,128) );
  MJ^.LoadDXF('MJ.DXF');
  for J := 0 to MaxText do
  begin
    Line := Font.CreateStr(Text[J]);
    New( Words[J], Init( Line^.Size, nil, nil ) );
    if (Line = nil) or (Words[J] = nil) then Break;
    P := Line^.Data;
    H := Line^.Size.X*Line^.Size.Y;
    asm
      push ds
      lds si,P
      mov cx,H
  @loop:
      shr byte ptr [si],4
      inc si
      dec cx
      jnz @loop
      pop ds
    end;
    Smooth( Line, Words[J] );
    Line^.Free;
  end;
  Font.Done;
  FillChar( Pal, SizeOf(Pal ), 0 );
  CurPal := Pal;
  for J := 0 to 63 do
  begin
    Pal[J].R := (J) shr 2 + 8;
    Pal[J].G := (J) shr 2 + 8;
    Pal[J].B := (J) shr 2 + 8;
  end;
  for J := 128 to 255 do
  begin
    Pal[J].R := (J-128) shr 2 + 8;
    Pal[J].G := (J-128) shr 1 + 8;
    Pal[J].B := (J-128) shr 2 + 8;
  end;
  SetPalette( @CurPal );
  VScreen := DosAllocMem(64000);
  LU.X := 0; LU.Y := 0;
  RU.X := 320 div 20; RU.Y := 0;
  LB.X := 0; LB.Y := 200 div 20;
  RB.X := 320 div 20; RB.Y := 200  div 20;
  Angle := 182;
  ToR.A.X := 0;
  ToR.A.Y := 0;
  ToR.B.X := 319;
  ToR.B.Y := 199;
  K := 10; KMul := 1.01;
  while FrameCount <= 150 do
  begin
    DoBack;
    MJ^.Rotate( 160, 100, 6 );
    MJ^.Scale( 160, 100, KMul*1.05, KMul*1.05 );
    MJ^.Draw(VScreen);
    if FrameCount-Prev >= LineCount then
    begin
      Prev := FrameCount;
      DoLine;
    end;
    for J := 0 to 255 do
    begin
      if Pal[J].R-CurPal[J].R < 1 then
	CurPal[J].R := Pal[J].R
      else
	Inc(CurPal[J].R,1);
      if Pal[J].G-CurPal[J].G < 1 then
	CurPal[J].G := Pal[J].G
      else
	Inc(CurPal[J].G,1);
      if Pal[J].B-CurPal[J].B < 1 then
	CurPal[J].B := Pal[J].B
      else
	Inc(CurPal[J].B,0);
    end;
    WaitNextFrame;
    SetPalette(@CurPal);
    CopyPage( VScreen, Screen );
    if KeyPressed then Abort;
  end;
  KMul := 0.997;
  FrameCount := 0;
  Prev := 0;
  while FrameCount < 150 do
  begin
    DoBack;
    MJ^.Rotate( 160, 100, 6 );
    MJ^.Scale( 160, 100, KMul, KMul );
    MJ^.Draw(VScreen);
    if FrameCount-Prev >= LineCount then
    begin
      DoLine;
      Prev := FrameCount;
    end;
    WaitNextFrame;
    CopyPage( VScreen, Screen );
    if KeyPressed then Abort;
  end;

  KMul := 0.99;
  MJ1 := MJ;
  New( MJ, Init(@PDrawHLineGr,128) );
  MJ^.LoadDxf('MJ1.DXF');
  MJName := 'MJ1.DXF';

  for I := 1 to 6 do
  begin
    KMul := 2-KMul;
    New( MJ2, Init(@PDrawHLineGr,128) );
    Inc(MJName[3]);
    MJ2^.LoadDxf(MJName);
    FrameCount := 0;
    Prev := 0;
    while FrameCount <= MorphSteps do
    begin
      DoBack;
      MJ^.MorphTo( MJ1, MJ2, FrameCount, MorphSteps );
      MJ^.Draw(VScreen);
      if FrameCount-Prev >= LineCount then
      begin
	DoLine;
	Prev := FrameCount;
      end;
      WaitNextFrame;
      CopyPage( VScreen, Screen );
      if KeyPressed then Abort;
    end;

    FrameCount := 0;
    Prev := 0;
    while FrameCount < RotSteps do
    begin
      DoBack;
      MJ^.Rotate(160,100,6);
      MJ^.Draw(VScreen);
      if FrameCount-Prev >= LineCount then
      begin
	DoLine;
	Prev := FrameCount;
      end;
      WaitNextFrame;
      CopyPage( VScreen, Screen );
      if KeyPressed then Abort;
    end;

    MJ1^.Free;
    MJ1 := MJ; MJ := MJ2;
  end;

  FrameCount := 0;
  Prev := 0;
  while FrameCount < RotSteps+63 do
  begin
    DoBack;
    MJ1^.Rotate( 160, 100, 6 );
    MJ1^.Scale( 160, 100, KMul/1.04, KMul/1.04 );
    MJ1^.Draw(VScreen);
{    if FrameCount > 5 then DoLine;}
    WaitNextFrame;
    CopyPage( VScreen, Screen );
{
    if FrameCount > RotSteps then
      SetVolume( 64-(FrameCount-RotSteps) );
}
  end;

  DosFreeMem( VScreen );
  MJ1^.Free;
  MJ2^.Free;
  for J := 0 to MaxText do
  begin
    if Words[J] = nil then Break;
    Words[J]^.Free;
  end;
  Smoke.Done;
{$IFDEF DEBUG}
  WriteLn( MemF, 'Free memory: ', DosMemAvail );
{$ENDIF}
end;

end.