{$I DEBUG}
unit Musax;

interface

procedure InitMusic( SaveConfig: Boolean );
procedure DoneMusic;
procedure StartMusic( Name: String );
procedure StopMusic;
procedure SetVolume( Vol: Integer );

implementation

uses midas, mplayer, sdevice, mconfig, s3m, mfile, Strings, VgaGraph;

var
  OldPlayer,
  Player:	PmpModule;

procedure InitMusic( SaveConfig: Boolean );
var
  I:	Integer;
begin
  midasSetDefaults;                   { set MIDAS defaults }
  fileExists('GLITCH.CFG', @I);
  if (I <> 1) or SaveConfig then
  begin
    midasConfig;
    if SaveConfig then midasSaveConfig('GLITCH.CFG');
  end
  else
    midasLoadConfig('GLITCH.CFG');       { load configuration }
  midasInit;                          { initialize MIDAS Sound System }
end;

procedure StartMusic( Name: String );
var
  I:	Integer;
  S:	array[0..79] of Char;
begin
  if midasSD <> nil then
  begin
{$IFDEF DEBUG}
    WriteLn( MemF, 'MIDAS : Loading ', Name, ' free mem :', MemAvail );
{$ENDIF}
    OldPlayer := Player;
    StrPCopy( S, Name );
    Player := midasLoadModule( @S, @mpS3M, NIL);
{$IFDEF DEBUG}
    if Player <> nil then
      WriteLn( MemF, 'MIDAS : Loaded ', Name, ' free mem :', MemAvail )
    else
      WriteLn( MemF, 'MIDAS : Failed to load ', Name, ' free mem :', MemAvail );
{$ENDIF}
    if (OldPlayer <> nil) and (Player<>nil) then
      midasStopModule(OldPlayer);
    if Player <> nil then
    begin
      midasPlayModule(Player, 1);
      if midasSD <> nil then
	PSoundDevice(midasSD)^.SetMasterVolume( 63 );
      if OldPlayer <> nil then
	midasFreeModule(OldPlayer);
    end;
{$IFDEF DEBUG}
    WriteLn( MemF, 'MIDAS : Deleted old module, free mem :', MemAvail );
{$ENDIF}
  end;
end;

procedure StopMusic;
begin
  if Player <> nil then
  begin
    midasStopModule(Player);
    midasFreeModule(Player);
  end;
  Player := nil;
end;

procedure SetVolume( Vol: Integer);
begin
  if midasSD <> nil then
  begin
    if Vol < 0 then Vol := 0;
    PSoundDevice(midasSD)^.SetMasterVolume( Vol );
  end;
end;

procedure DoneMusic;
begin
  midasClose;                         { uninitialize MIDAS }
end;

end.