{$I DEBUG}
unit Reflex;

interface

procedure DoReflex;

implementation

uses VgaGraph, CRT, Fonts, Objects, Polygon, Frames, Light, Musax, RStream;

const
  TotalLength = 580;

type
  TWordBuffer = array[0..32000] of Integer;
  PWordBuffer = ^TWordBuffer;

procedure SmoothSeg( FromPtr: Pointer ); assembler;
asm
  push ds
  lds si,FromPtr
  push ds
  pop es
  add si,256*10
  mov cx,128
@loop_y:
  push cx
  mov cx,236
  add si,10
@loop_x:
  xor ah,ah
  mov al,[si+1]
  add al,[si-1]
  adc ah,0
  add al,[si-256]
  adc ah,0
  add al,[si+256]
  adc ah,0
  shr ax,2
  mov es:[si],al
  inc si
  loop @loop_x
  add si,10
  pop cx
  loop @loop_y
  pop ds
end;

procedure ClearSeg( ToPtr: Pointer ); assembler;
asm
  push ds
  les di,ToPtr
  mov cx,256*140/4
  db $66; xor ax,ax
  db $66; rep stosw
  pop ds
end;

procedure ReflexOper( Buf: Pointer; Oper: PBuffer ); assembler;
asm
  push ds
  lds si,Buf
  mov si,320*3
  xor bh,bh
  mov cx,67
  les di,Oper
  push bp
  mov bp,576*2
  mov dx,64000-320
@loop_y:
  push cx
  mov cx,320
  push di
@loop_x:

  mov bx,es:[di]
  add bx,es:[bp]
  mov bl,[si+bx]
  or bl,128
  xchg si,dx
  mov [si],bl
  xchg si,dx
  add di,2
  inc si
  inc dx
  loop @loop_x
  pop di
  pop cx
  add si,320
  add bp,2
  sub dx,640
  loop @loop_y
  pop bp
  pop ds
end;

procedure DoReflex;

const
  XMax	= 2;
  XMin	= 1;
  YMax	= 3;
  YMin	= 0;

var
  Pic:		TImage;
  Buf1,
  Buf2,
  Tmp:		Pointer;
  RealOper,
  Oper: 	PWordBuffer;
  I, J:		Integer;
  Offset,
  OfsStep:	Byte;
  XAmp, YAmp,
  XStep, YStep:	Integer;
  Origin,
  Size:		TPoint;
  Shape:	TCompoundObject;
  ShapeImage:	TImage;
  L:		TLightning;
  CurPal,
  LPal:		TRGBPalette;
  Origin1:	TPoint;
  PicLen:	Word;
  S:		TRStream;
  Prev:		LongInt;

begin
  Origin.X := 240;
  Origin.Y := 0;
  Size.X := 256;
  Size.Y := 256;
  Origin1.X := 0;
  Origin1.Y := 0;
  Prev := FrameCount;

  S.Init( 'CROSS.3D' );
  Shape.Load(S);
  S.Done;
  ShapeImage.Init( Size, nil, nil );

  ShapeImage.Size.Y := 134;
  Buf2 := DosAllocMem( 65536 );
  Oper := DosAllocMem( 1024*2*2 );
  RealOper := DosAllocMem( 1024*2*2 );

  if not Pic.Load( 'RIVER3.NEW' ) or
  (Buf2=nil) or (ShapeImage.Data=nil) or (Oper=nil) or (RealOper=nil) then
  begin
    WriteLn( 'Something goes wrong...');
    ReadKey;
    Exit;
  end;

  for I := 0 to 63 do
  begin

    Pic.Palette^[I+64] := Pic.Palette^[I];
{
    if Pic.Palette^[I+64].R < 48 then
      Inc(Pic.Palette^[I+64].R,16)
    else
      Pic.Palette^[I+128+64].R := 63;
    if Pic.Palette^[I+64].G < 48 then
      Inc(Pic.Palette^[I+64].G,16)
    else
      Pic.Palette^[I+128+64].G := 63;
}
    Pic.Palette^[I].R := I;
    Pic.Palette^[I].G := I shr 1;
    Pic.Palette^[I].B := 0;
  end;
  for I := 0 to 127 do
  begin

    Pic.Palette^[I+128] := Pic.Palette^[I];

    if Pic.Palette^[I+128].B < 54 then
      Inc(Pic.Palette^[I+128].B,10)
    else
      Pic.Palette^[I+128].B := 63;

    if Pic.Palette^[I+128].R > 8 then
      Dec(Pic.Palette^[I+128].R,8)
    else
      Pic.Palette^[I+128].R := 0;
    if Pic.Palette^[I+128].G > 8 then
      Dec(Pic.Palette^[I+128].G,8)
    else
      Pic.Palette^[I+128].G := 0;
{
    Pic.Palette^[I+128].R := I;
    Pic.Palette^[I+128].G := 0;
    Pic.Palette^[I+128].B := I shr 1;
}
  end;
  FillChar( CurPal, 768, 0 );
  CurPal[255].R := 50;
  CurPal[255].G := 50;
  CurPal[255].B := 63;

  Buf1 := Pic.Data;
  PicLen := Pic.Size.X*Pic.Size.Y;
  asm
    push ds
    lds si,Buf1
    mov cx,PicLen
@loop:
    add byte ptr [si],64
    inc si
    loop @loop
    pop ds
  end;
  Offset := 0; OfsStep := 1;
  XAmp := XMax; YAmp := YMax;
  XStep := 1; YStep := 1;
  for I := 0 to 575 do
    Oper^[I] := Round( Sin(Pi*I/15)*YMax );
  for I := 0 to 575 do
    Oper^[576+I] := Round( Sin(Pi*I/17)*XMax );
  FrameCount := 0;

  while FrameCount < TotalLength do
  begin
{    Move( Buf1^, Buf2^, 320*140 );}
    Origin1.X := -FrameCount div 4;
    Pic.Show( Origin1, Buf2 );

    for I := 0 to 575 do
    begin
      RealOper^[I+Offset] := 320*(Integer(Oper^[I+Offset])*YAmp div YMax);
    end;
    for I := 0 to 575 do
    begin
      RealOper^[576+I+Offset] := Integer(Oper^[576+I+Offset])*XAmp div XMax;
    end;

    if Random(5) = 0 then
    begin
{      GetPalette( @LPal );}
      LPal := CurPal;

      LPal[0].B := 15;
      for I := 1 to 255 do
      begin
	if LPal[I].R < 48 then Inc( LPal[I].R, 16 ) else LPal[I].R := 63;
	if LPal[I].G < 48 then Inc( LPal[I].G, 16 ) else LPal[I].G := 63;
	if LPal[I].B < 32 then Inc( LPal[I].B, 32 ) else LPal[I].B := 63;
      end;

      L.Init( PBuffer(Buf2) );
      for I := 1 to 160 do
      begin
	L.Update;
	L.Draw;
      end;
      L.Done;
      SetPalette( @LPal );
    end;

    Shape.Rotate( 0,0,0, 1,3,1 );
    ClearSeg( ShapeImage.Data );
    Shape.Draw( ShapeImage.Data );
    SmoothSeg( ShapeImage.Data );

    ShapeImage.ShowTGConst( Origin, Buf2, 10 );
    Origin.X := 320-FrameCount;

    ReflexOper( Buf2, @RealOper^[Offset] );
    Offset := FrameCount*OfsStep;

{    if (Offset = 0) or (Offset = 32) then OfsStep := -OfsStep;}

    Inc( XAmp,(FrameCount-Prev)*XStep );
    Inc( YAmp,(FrameCount-Prev)*YStep );
    Prev := FrameCount;
    if (YAmp <= YMin) then
    begin
      YStep := -YStep;
      YAmp := YMin;
    end;
    if (YAmp >= YMax) then
    begin
      YStep := -YStep;
      YAmp := YMax;
    end;
    if (XAmp <= XMin) then
    begin
      XStep := -XStep;
      XAmp := XMin;
    end;
    if (XAmp >= XMax) then
    begin
      XStep := -XStep;
      XAmp := XMax;
    end;

    if FrameCount < 64 then
    begin
      for I := 0 to 254 do
      begin
	CurPal[I].R := Integer(Pic.Palette^[I].R)*FrameCount div 64;
	CurPal[I].G := Integer(Pic.Palette^[I].G)*FrameCount div 64;
	CurPal[I].B := Integer(Pic.Palette^[I].B)*FrameCount div 64;
      end;
    end;
    if FrameCount > TotalLength-64 then
    begin
      SetVolume( TotalLength-FrameCount );
      for I := 0 to 254 do
      begin
	CurPal[I].R := Integer(Pic.Palette^[I].R)*(TotalLength-FrameCount) div 64;
	CurPal[I].G := Integer(Pic.Palette^[I].G)*(TotalLength-FrameCount) div 64;
	CurPal[I].B := Integer(Pic.Palette^[I].B)*(TotalLength-FrameCount) div 64;
      end;
    end;

    SetPalette(@CurPal);
    CopyPage( Buf2, Screen );
  end;

{  Shape.Done;}
  ShapeImage.Done;
  DosFreeMem( Buf2 );
  DosFreeMem( Oper );
  DosFreeMem( RealOper );
  Pic.Done;
  Shape.Done;
end;

end.