{$I DEBUG}
unit Start;

interface

procedure DoStart;

implementation

uses VGAGraph, Objects, RStream, Frames, MapToRct, CRT, Title, FireGlitch;

const
  Steps: Integer = 60;
  K = 1.1;

procedure DoStart;
var
  Back,
  Back1:	TImage;
  Origin,
  Size:         TPoint;
  SX,SY:        Real;
  Pal,
  Pal1:         TRGBPalette;
  VScreen:      Pointer;
  LU,RU,
  LB,RB:        TPoint;
  ToR:          TRect;
  R, CR,
  R0:            Real;
  Angle,
  R1:           Integer;
  S:		TRStream;
  HSize,
  VSize:	Word;
  Buf:		PBuffer;
  CurOffset,
  OffsetStep:	Word;
  Prev :	LongInt;
  I, J:         Integer;

begin
  VScreen := DosAllocMem( 64000 );
  FillChar( Pal, SizeOf(Pal), 63 );
  FadeToPalette( @Pal, 3 );
{
  Back.Load( 'QM.PCX' );
  SX := 320; SY := 200;
  for I := 1 to Steps do
  begin
    SX := SX*K;
    SY := SY*K;
  end;
  for I := 0 to Steps do
  begin
    Size.X := Round(SX);
    Size.Y := Round(SY);
    Origin.X := (320-Size.X) div 2;
    Origin.Y := (200-Size.Y) div 2;
    for J := 0 to 255 do
    begin
      if Pal[J].R > Back.Palette^[J].R+1 then Dec(Pal[J].R,2);
      if Pal[J].G > Back.Palette^[J].G+1 then Dec(Pal[J].G,2);
      if Pal[J].B > Back.Palette^[J].B+1 then Dec(Pal[J].B,2);
    end;
    Back.ShowRect( Origin, Size, VScreen );
    WaitNextFrame;
    SetPalette( @Pal );
    CopyPage( VScreen, Ptr( SegA000, 0 ) );
    SX := SX/K; SY := SY/K;
  end;
}

  FrameCount := 0;
  Prev := 0;
  Back.Load( 'QM1.PCX' );
  ToR.A.X := 0; ToR.A.Y := 0;
  ToR.B.X := 319; ToR.B.Y := 199;
  R := 128;
  for I := 1 to Steps do
  begin
    R := R/K;
  end;
  Angle := 0;
  while Angle < Steps*2 do
  begin
    CR := R;
    for I := 1 to FrameCount do
      CR := CR*K;
    R1 := Round(CR);
    if R1 > 128 then R1 := 128;
    if FrameCount > Steps then FrameCount := Steps;
    Angle := FrameCount*2;
    RU.X := 128-Round( (-R1*Cos(2*Pi/Steps*Angle)+R1*Sin(2*Pi/Steps*Angle)) );
    RU.Y := 128-Round( (R1*Cos(2*Pi/Steps*Angle)-(-R1)*Sin(2*Pi/Steps*Angle)) );
    LU.X := 128-Round( (R1*Cos(2*Pi/Steps*Angle)+R1*Sin(2*Pi/Steps*Angle)) );
    LU.Y := 128-Round( (R1*Cos(2*Pi/Steps*Angle)-R1*Sin(2*Pi/Steps*Angle)) );
    RB.X := 128-Round( (-R1*Cos(2*Pi/Steps*Angle)+(-R1)*Sin(2*Pi/Steps*Angle)) );
    RB.Y := 128-Round( (-R1*Cos(2*Pi/Steps*Angle)-(-R1)*Sin(2*Pi/Steps*Angle)) );
    LB.X := 128-Round( (R1*Cos(2*Pi/Steps*Angle)+(-R1)*Sin(2*Pi/Steps*Angle)) );
    LB.Y := 128-Round( (-R1*Cos(2*Pi/Steps*Angle)-R1*Sin(2*Pi/Steps*Angle)) );
    MapPicToRect( LU,RU,RB,LB, ToR, Back.Data, VScreen );
    for J := 0 to 255 do
    begin
      if Pal[J].R > Back.Palette^[J].R+1 then Dec(Pal[J].R,2);
      if Pal[J].G > Back.Palette^[J].G+1 then Dec(Pal[J].G,2);
      if Pal[J].B > Back.Palette^[J].B+1 then Dec(Pal[J].B,2);
    end;
    WaitNextFrame;
    SetPalette( @Pal );
    CopyPage( VScreen, Screen );
    if KeyPressed then Abort;
  end;
  Pal := Back.Palette^;
{
  R0 := 120;
  for I := 1 to Steps do
  begin
    R0 := R0/K;
  end;
  R := R0;
  R1 := Round(R);
  LU.X := 128-R1; LU.Y := 128-R1;
  RU.X := 128+R1; RU.Y := 128-R1;
  LB.X := 128-R1; LB.Y := 128+R1;
  RB.X := 128+R1; RB.Y := 128+R1;
  for I := 0 to Steps do
  begin
    R1 := Round(R);
    LU.X := 128-R1; LU.Y := 128-R1;
    MapPicToRect( LU,RU,RB,LB, ToR, Back.Data, VScreen );
    for J := 0 to 255 do
    begin
      if Pal[J].R > Back.Palette^[J].R+1 then Dec(Pal[J].R,2);
      if Pal[J].G > Back.Palette^[J].G+1 then Dec(Pal[J].G,2);
      if Pal[J].B > Back.Palette^[J].B+1 then Dec(Pal[J].B,2);
    end;
    WaitNextFrame;
    SetPalette( @Pal );
    CopyPage( VScreen, Ptr( SegA000, 0 ) );
    R := R*K;
  end;
  R := R0;
  for I := 0 to Steps do
  begin
    R1 := Round(R);
    RU.X := 128+R1; RU.Y := 128-R1;
    MapPicToRect( LU,RU,RB,LB, ToR, Back.Data, VScreen );
    MapRectToPic( LU,RU,RB,LB, Back.Data, VScreen );
    for J := 0 to 255 do
    begin
      if Pal[J].R > Back.Palette^[J].R+1 then Dec(Pal[J].R,2);
      if Pal[J].G > Back.Palette^[J].G+1 then Dec(Pal[J].G,2);
      if Pal[J].B > Back.Palette^[J].B+1 then Dec(Pal[J].B,2);
    end;
    WaitNextFrame;
    SetPalette( @Pal );
    CopyPage( VScreen, Ptr( SegA000, 0 ) );
    R := R*K;
  end;
  R := R0;
  for I := 0 to Steps do
  begin
    R1 := Round(R);
    LB.X := 128-R1; LB.Y := 128+R1;
    MapPicToRect( LU,RU,RB,LB, ToR, Back.Data, VScreen );
    MapRectToPic( LU,RU,RB,LB, Back.Data, VScreen );
    for J := 0 to 255 do
    begin
      if Pal[J].R > Back.Palette^[J].R+1 then Dec(Pal[J].R,2);
      if Pal[J].G > Back.Palette^[J].G+1 then Dec(Pal[J].G,2);
      if Pal[J].B > Back.Palette^[J].B+1 then Dec(Pal[J].B,2);
    end;
    WaitNextFrame;
    SetPalette( @Pal );
    CopyPage( VScreen, Ptr( SegA000, 0 ) );
    R := R*K;
  end;
  R := R0;
  for I := 0 to Steps do
  begin
    R1 := Round(R);
    RB.X := 128+R1; RB.Y := 128+R1;
    MapPicToRect( LU,RU,RB,LB, ToR, Back.Data, VScreen );
    for J := 0 to 255 do
    begin
      if Pal[J].R > Back.Palette^[J].R+1 then Dec(Pal[J].R,2);
      if Pal[J].G > Back.Palette^[J].G+1 then Dec(Pal[J].G,2);
      if Pal[J].B > Back.Palette^[J].B+1 then Dec(Pal[J].B,2);
    end;
    WaitNextFrame;
    SetPalette( @Pal );
    CopyPage( VScreen, Ptr( SegA000, 0 ) );
    R := R*K;
  end;
}
{
  Back1.Load( 'QM2.PCX' );
  R1 := 91;
  Steps := (R1 div 3) -1;
  LU.X := R1; LU.Y := R1;
  RU.X := 320-R1; RU.Y := R1;
  LB.X := R1; LB.Y := 200-R1;
  RB.X := 320-R1; RB.Y := 200-R1;
  for I := 0 to Steps do
  begin
    Dec(LU.X,3);
    Dec(LU.Y,3);
    CopyPage( Back1.Data, VScreen );
    MapRectToPic( LU,RU,RB,LB, Back.Data, VScreen );
    for J := 0 to 255 do
    begin
      if Pal[J].R > Back.Palette^[J].R+1 then Dec(Pal[J].R,2);
      if Pal[J].G > Back.Palette^[J].G+1 then Dec(Pal[J].G,2);
      if Pal[J].B > Back.Palette^[J].B+1 then Dec(Pal[J].B,2);
    end;
    WaitNextFrame;
    SetPalette( @Pal );
    CopyPage( VScreen, Screen );
  end;
  for I := 0 to 255 do
  begin
    if Pal[I].R < 54 then Inc( Pal[I].R, 10 );
    if Pal[I].G < 54 then Inc( Pal[I].G, 10 );
    if Pal[I].B < 54 then Inc( Pal[I].B, 10 );
  end;
  FadeToPalette( @Pal, 1 );
  for I := 0 to Steps do
  begin
    Inc(RU.X,3);
    Dec(RU.Y,3);
    CopyPage( Back1.Data, VScreen );
    MapRectToPic( LU,RU,RB,LB, Back.Data, VScreen );
    for J := 0 to 255 do
    begin
      if Pal[J].R > Back.Palette^[J].R+1 then Dec(Pal[J].R,2);
      if Pal[J].G > Back.Palette^[J].G+1 then Dec(Pal[J].G,2);
      if Pal[J].B > Back.Palette^[J].B+1 then Dec(Pal[J].B,2);
    end;
    WaitNextFrame;
    SetPalette( @Pal );
    CopyPage( VScreen, Screen );
  end;
  for I := 0 to 255 do
  begin
    if Pal[I].R < 54 then Inc( Pal[I].R, 10 );
    if Pal[I].G < 54 then Inc( Pal[I].G, 10 );
    if Pal[I].B < 54 then Inc( Pal[I].B, 10 );
  end;
  FadeToPalette( @Pal, 1 );
  for I := 0 to Steps do
  begin
    Dec(LB.X,3);
    Inc(LB.Y,3);
    CopyPage( Back1.Data, VScreen );
    MapRectToPic( LU,RU,RB,LB, Back.Data, VScreen );
    for J := 0 to 255 do
    begin
      if Pal[J].R > Back.Palette^[J].R+1 then Dec(Pal[J].R,2);
      if Pal[J].G > Back.Palette^[J].G+1 then Dec(Pal[J].G,2);
      if Pal[J].B > Back.Palette^[J].B+1 then Dec(Pal[J].B,2);
    end;
    WaitNextFrame;
    SetPalette( @Pal );
    CopyPage( VScreen, Screen );
  end;
  for I := 0 to 255 do
  begin
    if Pal[I].R < 54 then Inc( Pal[I].R, 10 );
    if Pal[I].G < 54 then Inc( Pal[I].G, 10 );
    if Pal[I].B < 54 then Inc( Pal[I].B, 10 );
  end;
  FadeToPalette( @Pal, 1 );
  for I := 0 to Steps do
  begin
    Inc(RB.X,3);
    Inc(RB.Y,3);
    CopyPage( Back1.Data, VScreen );
    MapRectToPic( LU,RU,RB,LB, Back.Data, VScreen );
    for J := 0 to 255 do
    begin
      if Pal[J].R > Back.Palette^[J].R+1 then Dec(Pal[J].R,2);
      if Pal[J].G > Back.Palette^[J].G+1 then Dec(Pal[J].G,2);
      if Pal[J].B > Back.Palette^[J].B+1 then Dec(Pal[J].B,2);
    end;
    WaitNextFrame;
    SetPalette( @Pal );
    CopyPage( VScreen, Screen );
  end;
}
  CopyPage( Screen, VScreen );
  FrameCount := 0;
  for J := 2 to 255 do
  begin
    Pal[J].R := J shr 2;
    Pal[J].G := J shr 3;
    Pal[J].B := J shr 3;
  end;
  while FrameCount < 45 do
  begin
{
    for J := 2 to 255 do
    begin
      if Pal[J].R > (J shr 2)+1 then Dec( Pal[J].R, 2 );
      if Pal[J].R < (J shr 2)-1 then Inc( Pal[J].R, 2 );
      if Pal[J].G > (J shr 2)+1 then Dec( Pal[J].G, 2 );
      if Pal[J].G < (J shr 2)-1 then Inc( Pal[J].G, 2 );
      if Pal[J].B > (J shr 2)+1 then Dec( Pal[J].B, 2 );
      if Pal[J].B < (J shr 2)-1 then Inc( Pal[J].B, 2 );
    end;
}
    SmoothPage( VScreen, VScreen );

{    WaitNextFrame;}
    SetPalette( @Pal );
    CopyPage( VScreen, Screen );
  end;
  DosFreeMem( VScreen );
  FillChar( Pal1, SizeOf(Pal1), 31 );
  Back.Done;
{  Back1.Done;}
  Back.Load( 'QM2.PCX' );
{  for I := 1 to 20 do WaitNextFrame;}
  FadeToPalette( @Pal1, 3 );
  for J := 0 to 15 do
  begin
    for I := 0 to 15 do
    begin
      Pal[J*16+I].R := J*4;
      Pal[J*16+I].G := J*4;
      Pal[J*16+I].B := J*4;
    end;
  end;
  Move( Back.Data^, Ptr( SegA000,0 )^, 64000 );
  FadeToPalette( @Pal, 3 );
{$IFDEF DEBUG}
  WriteLn( MemF, 'Init Title' );
{$ENDIF}


  if Title.Init( Back.Data ) then Title.Run;
  Title.Done;

{$IFDEF DEBUG}
  WriteLn( MemF, 'Done Title' );
{$ENDIF}
  Back.Done;
  Back.Load( 'QM2.PCX' );
  WaitNextFrame;
  Move( Back.Data^, Ptr( SegA000,0 )^, 64000 );
{$IFDEF DEBUG}
  WriteLn( MemF, 'Init Fire' );
{$ENDIF}
  if FireGlitch.Init( Back.Data ) then FireGlitch.Run;
  FireGlitch.Done;
{$IFDEF DEBUG}
  WriteLn( MemF, 'Done Fire' );
{$ENDIF}
  Back.Done;
end;

end.
