{$I DEBUG}
unit Title;

interface

function Init( Back: Pointer ): Boolean;
procedure Run;
procedure Done;

implementation

uses VGAGraph, Fonts, CRT, Objects, Frames;

var
  Tmp:		Pointer;
  BackPic:	Pointer;
  Pal:	TRGBPalette;

function Init( Back: Pointer ): Boolean;
var
  I,J:	Integer;
begin
  BackPic := Back;
  Tmp := DosAllocMem( 64000 );
  if (Tmp=nil) then
    Init := False
  else
    Init := True;
  GetPalette( @Pal );
  for J := 0 to 7 do
  begin
    for I := 1 to 15 do
    begin
      Pal[J*16+I].R := Pal[J*16+I-1].R + 2;
{      Pal[J*16+I].G := Pal[J*16+I-1].G + 2;}
{      Pal[J*16+I].B := Pal[J*16+I-1].B + 2;}
    end;
  end;
  for J := 8 to 15 do
  begin
    Pal[J*16] := Pal[J*16-128];
    for I := 1 to 15 do
    begin
      Pal[J*16+I].R := Pal[J*16+I-1].R + 2;
      Pal[J*16+I].G := Pal[J*16+I-1].G + 2;
      Pal[J*16+I].B := Pal[J*16].B;
{      Pal[J*16+I].B := Pal[J*16+I-1].B + 2;}
    end;
  end;
  SetPalette( @Pal );
end;

procedure Run;

procedure ShowStr( Font, St: String; VPos: Integer; Add: Byte; FrameN: Integer );
const
  K = 1.0;
var
  I,J:		Integer;
  Orig:		PImage;
  Dest:		array[ 0..20 ] of PImage;
  O,
  S:		TPoint;
  P:		Pointer;
  H,V:		Integer;
  F:		TFont;
  VS,
  HS:		Integer;
  R:		Real;

begin
  if not F.Load( Font ) then Halt;
  Orig := F.CreateStr(St);
  if Orig = nil then Halt;
  F.Done;
  R := 1;
  for I := 1 to FrameN do R := R*K;
  P := Orig^.Data;
  H := Orig^.Size.X*Orig^.Size.Y;
  asm
    push ds
    lds si,P
    mov cx,H
@loop:
    shr byte ptr [si],4
    inc si
    dec cx
    jnz @loop
    pop ds
  end;
  Dest[0] := Orig;
  for I := 1 to FrameN do
  begin
    Dest[I] := New( PImage, Init( Orig^.Size, nil, nil ) );
    if Dest[I] = nil then Halt;
    Smooth( Dest[I-1], Dest[I] );
  end;
  H := Dest[I]^.Size.X*Dest[i]^.Size.Y;
  for I := FrameN downto 0 do
  begin
    CopyPage( BackPic, Tmp );
    P := Dest[I]^.Data;
    asm
      push ds
      lds si,P
      mov cx,H
      mov al,Add
  @loop:
      mov ah,[si]
      or ah,ah
      jz @no_add
      add byte ptr [si],al
@no_add:
      inc si
      dec cx
      jnz @loop
      pop ds
    end;
    S.X := Round(Orig^.Size.X*R);
    S.Y := Round(Orig^.Size.Y*R);
    O.X := 160 - S.X div 2;
    O.Y := VPos - S.Y div 2;
    R := R/K;
    Dest[I]^.ShowRectAddT( O, S, Tmp );
    WaitNextFrame;
    CopyPage( Tmp, Ptr( SegA000,0 ) );
  end;
  for I := FrameN downto 0 do
    Dest[I]^.Free;
  CopyPage( Ptr( SegA000,0 ), BackPic );
end;

const
  TitleSteps	= 9;
var
  I,J:		Integer;
begin
  FrameCount := 0;
  ShowStr( 'STAMP36.FNT', 'QUEUE', 40, 0, TitleSteps );
  ShowStr( 'OTTAWA28.FNT', 'Members Group', 90, 0, TitleSteps );
  ShowStr( 'OTTAWA28.FNT', 'presents', 150, 128, TitleSteps );
  for J := 0 to 7 do
  begin
    for I := 0 to 15 do
    begin
      Pal[J*16+I].R := J*4;
      Pal[J*16+I].G := J*4;
      Pal[J*16+I].B := J*4;
    end;
  end;
  while FrameCount < 110 do;
  FrameCount := 0;
  FadeToPalette( @Pal, 15 );
  Move( Pal[0], Pal[128], SizeOf(Pal) div 2 );
  FadeToPalette( @Pal, 15 );
  asm
    push ds
    les di,Screen
    lds si,BackPic
    mov cx,32000
    mov ax,$7070
@loop:
    and word ptr [si],ax
    movsw
    dec cx
    jnz @loop
    pop ds
  end;
  for J := 8 to 15 do
  begin
    for I := 1 to 15 do
    begin
      Pal[J*16+I].R := Pal[J*16+I-1].R + 2;
    end;
  end;
  for J := 0 to 7 do
  begin
    for I := 1 to 15 do
    begin
      Pal[J*16+I].G := Pal[J*16+I-1].G + 2;
      Pal[J*16+I].B := Pal[J*16+I-1].B + 2;
    end;
  end;
  SetPalette( @Pal );
  ShowStr( 'STAMP36.FNT', 'QMG', 30, 0, TitleSteps );
  ShowStr( 'MYSTIC40.FNT', 'Art', 80, 128, TitleSteps );
  ShowStr( 'MYSTIC40.FNT', 'Division', 125, 128, TitleSteps );
  ShowStr( 'OTTAWA28.FNT', 'production', 170, 0, TitleSteps );
  for J := 0 to 7 do
  begin
    for I := 0 to 15 do
    begin
      Pal[J*16+I].R := J*4;
      Pal[J*16+I].G := J*4;
      Pal[J*16+I].B := J*4;
    end;
  end;
  while FrameCount < 170 do;
  FadeToPalette( @Pal, 15 );
  Move( Pal[0], Pal[128], SizeOf(Pal) div 2 );
  FadeToPalette( @Pal, 15 );
end;

procedure Done;
begin
  DosFreeMem( Tmp );
end;

end.